///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit IshForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, MySys, KOLClearDir;

type
  TIshF = class(TForm)
    CloseBut: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    databasedirLab: TLabel;
    Label2: TLabel;
    IshDirLab: TLabel;
    KlepIshBut: TButton;
    DelBaseBut: TButton;
    ResbildnutBaseBut: TButton;
    KlepIshLmpBut: TButton;
    DelBaseLmpBut: TButton;
    ResbildnutBaseLmpBut: TButton;
    IshLmpDirLab: TLabel;
    Label5: TLabel;
    databaselmpdirLab: TLabel;
    Label7: TLabel;
    RefreshFbUt: TButton;
    UnPackBasBut: TButton;
    UnPackLmpBasBut: TButton;
    FullGetBaseBut: TButton;
    FullMakeBaseBut: TButton;
    FullGetLmpBaseBut: TButton;
    FullMakeLmpBaseBut: TButton;
    procedure CloseButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RefreshFbUtClick(Sender: TObject);
    procedure KlepIshButClick(Sender: TObject);
    procedure KlepIshLmpButClick(Sender: TObject);
    procedure DelBaseButClick(Sender: TObject);
    procedure DelBaseLmpButClick(Sender: TObject);
    procedure ResbildnutBaseButClick(Sender: TObject);
    procedure ResbildnutBaseLmpButClick(Sender: TObject);
    procedure UnPackBasButClick(Sender: TObject);
    procedure UnPackLmpBasButClick(Sender: TObject);
    procedure FullGetBaseButClick(Sender: TObject);
    procedure FullGetLmpBaseButClick(Sender: TObject);
    procedure FullMakeBaseButClick(Sender: TObject);
    procedure FullMakeLmpBaseButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    IshMenalsa : boolean;
  end;

Procedure RefreshF;

var
  IshF: TIshF;

implementation

uses DelF;

var
  ShowMess, CanClep, CanDel, CanClepLmp, CanDelLmp : boolean;

{$R *.DFM}

Procedure RefreshF;
var
  vseNameste : boolean;

begin
  // "" .     
  //  .

  // -.
  CanClep := true;
  CanDel := true;
  CanClepLmp := true;
  CanDelLmp := true;
  // .
  databasedir := GetExtensDirName(DatabaseResPath);
  databaselmpdir := GetExtensDirName(DatabaselmpResPath);
  IshDir := DatabaseResIsh;
  IshlmpDir := DatabaselmpResIsh;
  //   
  IshF.databasedirlab.Caption := databasedir;
  IshF.DatabaseLmpDirLab.Caption := DatabaseLmpDir;
  IshF.IshDirLab.Caption := IshDir;
  IshF.IshLmpDirLab.Caption := IshLmpDir;

  //        .
  If DirectoryExists(databasedir) = true then begin
    vseNameste := true;
    If FileExistsDiv('items.idb',databasedir) = false then VseNameste := false;
    If FileExistsDiv('perks.pdb',databasedir) = false then VseNameste := false;
    If FileExistsDiv('acks.db',databasedir) = false then VseNameste := false;
    If FileExistsDiv('prints.db',databasedir) = false then VseNameste := false;
    If FileExistsDiv('levers.ldb',databasedir) = false then VseNameste := false;
    If FileExistsDiv('quests.qdb',databasedir) = false then VseNameste := false;
    If FileExistsDiv('spells.sdb',databasedir) = false then VseNameste := false;
    If FileExistsDiv('units.udb',databasedir) = false then VseNameste := false;
    If VseNameste then begin
      //  .
      IshF.databasedirlab.Font.Color := ClGreen;
      IshF.KlepIshBut.Enabled := true;
    end
    else begin
      IshF.databasedirlab.Font.Color := ClRed;
      CanClep := false;
      IshF.KlepIshBut.Enabled := false;
    end;
  end
  else begin
    IshF.databasedirlab.Font.Color := ClRed;// 
    CanClep := false;   // .
    IshF.KlepIshBut.Enabled := false;
  end;

  //        .
  If DirectoryExists(databaselmpdir) = true then begin
    vseNameste := true;
    If FileExistsDiv('items.idb',databaselmpdir) = false then VseNameste := false;
    If FileExistsDiv('perks.pdb',databaselmpdir) = false then VseNameste := false;
    If FileExistsDiv('prints.db',databaselmpdir) = false then VseNameste := false;
    If FileExistsDiv('levers.ldb',databaselmpdir) = false then VseNameste := false;
    If FileExistsDiv('spells.sdb',databaselmpdir) = false then VseNameste := false;
    If FileExistsDiv('units.udb',databaselmpdir) = false then VseNameste := false;
    If VseNameste then begin
      //  .
      IshF.databaselmpdirlab.Font.Color := ClGreen;
      IshF.KlepIshLmpBut.Enabled := true;
    end
    else begin
      IshF.databaselmpdirlab.Font.Color := ClRed;
      CanClepLmp := false;
      IshF.KlepIshLmpBut.Enabled := false;
    end;
  end
  else begin
    IshF.databaselmpdirlab.Font.Color := ClRed;// 
    CanClepLmp := false;
    IshF.KlepIshLmpBut.Enabled := false;
  end;

  //          .
  If DirectoryExists(IshDir) = true then begin
    vseNameste := true;
    if DirectoryExists(IshDir+'items\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'perks\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'acks\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'prints\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'levers\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'quests\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'spells\') = false then VseNameste := false;
    if DirectoryExists(IshDir+'units\') = false then VseNameste := false;
    If VseNameste then begin
      IshF.IshDirlab.Font.Color := ClGreen;
      IshF.DelBaseBut.Enabled := true;
      IshF.ResbildnutBaseBut.Enabled := true;
      IshF.FullMakeBaseBut.Enabled := true;
    end  
    else begin
      IshF.IshDirlab.Font.Color := ClRed;
      CanDel := false;
      IshF.DelBaseBut.Enabled := false;
      IshF.ResbildnutBaseBut.Enabled := false;
      IshF.FullMakeBaseBut.Enabled := false;
    end;
  end
  else begin
    IshF.IshDirlab.Font.Color := ClRed;// 
    CanDel := false;
    IshF.DelBaseBut.Enabled := false;
    IshF.ResbildnutBaseBut.Enabled := false;
    IshF.FullMakeBaseBut.Enabled := false;
  end;

  //          .
  If DirectoryExists(IshLmpDir) = true then begin
    vseNameste := true;
    if DirectoryExists(IshLmpDir+'items\') = false then VseNameste := false;
    if DirectoryExists(IshLmpDir+'perks\') = false then VseNameste := false;
    if DirectoryExists(IshLmpDir+'prints\') = false then VseNameste := false;
    if DirectoryExists(IshLmpDir+'levers\') = false then VseNameste := false;
    if DirectoryExists(IshLmpDir+'spells\') = false then VseNameste := false;
    if DirectoryExists(IshLmpDir+'units\') = false then VseNameste := false;
    If VseNameste then begin
      IshF.IshLmpDirlab.Font.Color := ClGreen;
      IshF.DelBaseLmpBut.Enabled := true;
      IshF.ResbildnutBaseLmpBut.Enabled := true;
      IshF.FullMakeLmpBaseBut.Enabled := true;
    end  
    else begin
      IshF.IshLmpDirlab.Font.Color := ClRed;
      CanDelLmp := false;
      IshF.DelBaseLmpBut.Enabled := false;
      IshF.ResbildnutBaseLmpBut.Enabled := false;
      IshF.FullMakeLmpBaseBut.Enabled := false;
    end;
  end
  else begin
    IshF.IshLmpDirlab.Font.Color := ClRed;// 
    CanDelLmp := false;
    IshF.DelBaseLmpBut.Enabled := false;
    IshF.ResbildnutBaseLmpBut.Enabled := false;
    IshF.FullMakeLmpBaseBut.Enabled := false;
  end;

  //  - \  .
  If FileExists(DatabaseResPath) = true then begin
    //    ,    .
    IshF.UnPackBasBut.Enabled := true;
    IshF.FullGetBaseBut.Enabled := true;
  end
  else begin
    //  ,  ...
    IshF.UnPackBasBut.Enabled := false;
    IshF.FullGetBaseBut.Enabled := false;
  end;

  If FileExists(DatabaselmpResPath) = true then begin
    //    ,    .
    IshF.UnPackLmpBasBut.Enabled := true;
    IshF.FullGetLmpBaseBut.Enabled := true;
  end
  else begin
    //  ,  ...
    IshF.UnPackLmpBasBut.Enabled := false;
    IshF.FullGetLmpBaseBut.Enabled := false;
  end;

end;

procedure TIshF.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TIshF.FormShow(Sender: TObject);
begin
  RefreshF;
  ShowMess := true;
end;

procedure TIshF.RefreshFbUtClick(Sender: TObject);
begin
  RefreshF;
end;

procedure TIshF.KlepIshButClick(Sender: TObject);
var
  sdelaliDir, MoznoNachat : boolean;
begin
  If CanClep = true then begin
    //     .
    sdelaliDir := false;
    if DirectoryExists(IshDir) = false then begin
      ForceDirectories(IshDir);
      sdelaliDir := true;
    end;
    //   ,      ,
    // ,   ,    ...
    //  ,    .      .
    MoznoNachat := true;
    If DirectoryExists(IshDir) = true then begin
      If sdelaliDir = false then begin
        If ShowMess = true then begin
          //    .
          if MessageDLG(',      ! ?',mtWarning,[mbYes]+[mbNo],0) = mrNo then MoznoNachat := false;
        end;
      end;
      // "mozno nachat" :),  "nachat".
      If MoznoNachat = true then begin
        //  -  .
        ClearDir(IshDir,false);
        //.
        RaspakBase(databaseDir+'items.idb',IshDir);
        RaspakBase(databaseDir+'perks.pdb',IshDir);
        RaspakBase(databaseDir+'acks.db',IshDir);
        RaspakBase(databaseDir+'prints.db',IshDir);
        RaspakBase(databaseDir+'levers.ldb',IshDir);
        RaspakBase(databaseDir+'quests.qdb',IshDir);
        RaspakBase(databaseDir+'spells.sdb',IshDir);
        RaspakBase(databaseDir+'units.udb',IshDir);
        RefreshF;
        IshMenalsa := true;
      end;
    end;
  end
  else begin
    MessageDLG('  , ..     ,        ',mtError,[mbOk],0);
  end;
end;

procedure TIshF.KlepIshLmpButClick(Sender: TObject);
var
  sdelaliDir, MoznoNachat : boolean;
begin
  If CanClepLmp = true then begin
    //     .
    sdelaliDir := false;
    if DirectoryExists(IshLmpDir) = false then begin
      ForceDirectories(IshLmpDir);
      sdelaliDir := true;
    end;
    //   ,      ,
    // ,   ,    ...
    //  ,    .      .
    MoznoNachat := true;
    If DirectoryExists(IshLmpDir) = true then begin
      If sdelaliDir = false then begin
        If ShowMess = true then begin
          //    .
          if MessageDLG(',      ! ?',mtWarning,[mbYes]+[mbNo],0) = mrNo then MoznoNachat := false;
       end;
      end;
      // "mozno nachat" :),  "nachat".
      If MoznoNachat = true then begin
        //  -  .
        ClearDir(IshLmpDir,false);
        //.
        RaspakBase(databaseLmpDir+'items.idb',IshLmpDir);
        RaspakBase(databaseLmpDir+'levers.ldb',IshLmpDir);
        RaspakBase(databaseLmpDir+'perks.pdb',IshLmpDir);
        RaspakBase(databaseLmpDir+'prints.db',IshLmpDir);
        RaspakBase(databaseLmpDir+'spells.sdb',IshLmpDir);
        RaspakBase(databaseLmpDir+'units.udb',IshLmpDir);
        RefreshF;
        IshMenalsa := true;
      end;
    end;
  end
  else begin
    MessageDLG('  , ..     ,        ',mtError,[mbOk],0);
  end;
end;

procedure TIshF.DelBaseButClick(Sender: TObject);
var
  MoznoNachat : boolean;
begin
  If CanDel = true then begin
    //   ,  .
    //  ,   ,    ,   ...
    If DirectoryExists(ExtractFilePath(DatabaseResPath)) then begin
      // .
      MoznoNachat := false;
      if DirectoryExists(databaseDir) then begin
        If ShowMess = true then begin
          if MessageDLG('     .     . ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
            MoznoNachat := true;
            //ClearDir(databaseDir,true);
          end;
        end
        else begin
          //   ,    .
          MoznoNachat := true;
          //ClearDir(databaseDir,true);
        end;
      end
      else begin
        MkDir(databaseDir);
        moznoNachat := true;
      end;
      //  ,  ...
      If MoznoNachat then begin
        // ...
        //MkDir(databaseDir);
        //  ...
        ZapakBase(IshDir+'acks\',databaseDir+'acks.db');
        ZapakBase(IshDir+'items\',databaseDir+'items.idb');
        ZapakBase(IshDir+'levers\',databaseDir+'levers.ldb');
        ZapakBase(IshDir+'perks\',databaseDir+'perks.pdb');
        ZapakBase(IshDir+'prints\',databaseDir+'prints.db');
        ZapakBase(IshDir+'quests\',databaseDir+'quests.qdb');
        ZapakBase(IshDir+'spells\',databaseDir+'spells.sdb');
        ZapakBase(IshDir+'units\',databaseDir+'units.udb');
        //ShowMessage('');
        RefreshF;
      end;
    end
    else begin
      // 
      MessageDLG('  ,        .    !',mtError,[mbOk],0);
    end;
  end
  else begin
    MessageDLG('    , ..    ,        ',mtError,[mbOk],0);
  end;
end;

procedure TIshF.DelBaseLmpButClick(Sender: TObject);
var
  MoznoNachat : boolean;
begin
  If CanDelLmp = true then begin
    //   ,  .
    //  ,   ,    ,   ...
    If DirectoryExists(ExtractFilePath(DatabaselmpResPath)) then begin
      // .
      MoznoNachat := false;
      if DirectoryExists(databaseLmpDir) then begin
        If ShowMess = true then begin
          if MessageDLG('     .     . ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
            MoznoNachat := true;
            //ClearDir(databaseLmpDir,true);
          end;
        end
        else begin
          //   ,    .
          MoznoNachat := true;
          //ClearDir(databaseLmpDir,true);
        end;
      end
      else begin
        MkDir(databaseLmpDir);
        moznoNachat := true;
      end;
      //  ,  ...
      If MoznoNachat then begin
        // ...
        //MkDir(databaseLmpDir);
        //  ...
        ZapakBase(IshLmpDir+'items\',databaseLmpDir+'items.idb');
        ZapakBase(IshLmpDir+'levers\',databaseLmpDir+'levers.ldb');
        ZapakBase(IshLmpDir+'perks\',databaseLmpDir+'perks.pdb');
        ZapakBase(IshLmpDir+'prints\',databaseLmpDir+'prints.db');
        ZapakBase(IshLmpDir+'spells\',databaseLmpDir+'spells.sdb');
        ZapakBase(IshLmpDir+'units\',databaseLmpDir+'units.udb');
        //ShowMessage('');
        RefreshF;
      end;
    end
    else begin
      // 
      MessageDLG('  ,        .    !',mtError,[mbOk],0);
    end;
  end
  else begin
    MessageDLG('    , ..    ,        ',mtError,[mbOk],0);
  end;
end;

procedure TIshF.ResbildnutBaseButClick(Sender: TObject);
var
  CanDo : boolean;
begin
  // ""   .
  CanDo := false;
  If ShowMess = false then begin
    //    ,   ...
    CanDo := true;
  end
  else begin
    //...
    if MessageDLG('    .    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
      CanDo := true;
    end;
  end;

  if CanDo = true then begin
    {if fileexists(PathBases+'resbuild.exe') = false then begin
      CopyFile(Path+'resbuild.exe',PathBases+'resbuild.exe',nil);
    end; }
    If FileExists(DatabaseResPath) = true then begin
      SetFileAttributes(PChar(DatabaseResPath),FILE_ATTRIBUTE_ARCHIVE);
      DeleteFile(DatabaseResPath);
    end;
    //packresurs(databaseDir);
    ModalAddDirToRes(DatabaseResPath,databaseDir);
    ModalOptimizeRes(DatabaseResPath);
  end;
end;

procedure TIshF.ResbildnutBaseLmpButClick(Sender: TObject);
var
  CanDo : boolean;
begin
  // ""   .
  CanDo := false;
  If ShowMess = false then begin
    //    ,   ...
    CanDo := true;
  end
  else begin
    //...
    if MessageDLG('    .    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
      CanDo := true;
    end;
  end;

  if CanDo = true then begin
    If FileExists(DatabaselmpResPath) = true then begin
      SetFileAttributes(PChar(DatabaselmpResPath),FILE_ATTRIBUTE_ARCHIVE);
      DeleteFile(DatabaselmpResPath);
    end;
    ModalAddDirToRes(DatabaselmpResPath,databaseLmpDir);
    ModalOptimizeRes(DatabaseResPath);
  end;  
end;

procedure TIshF.UnPackBasButClick(Sender: TObject);
begin
  // database.res
  If messageDLG('      .  ?',mtWarning,[mbYes]+[mbNo],0) = mrYes then begin
    if DirectoryExists(databaseDir) = true then begin
      DelForm.DelPath := databaseDir;
      DelForm.ShowModal;
    end;
    MkDir(databaseDir);
    ModalUnPackResToDir(DatabaseResPath,databaseDir);
    RefreshF;
  end;
end;

procedure TIshF.UnPackLmpBasButClick(Sender: TObject);
begin
  // databaselmp.res
  If messageDLG('      .  ?',mtWarning,[mbYes]+[mbNo],0) = mrYes then begin
    if DirectoryExists(databaseLmpDir) = true then begin
      DelForm.DelPath := databaseLmpDir;
      DelForm.ShowModal;
    end;
    MkDir(databaseLmpDir);
    ModalUnPackResToDir(DatabaselmpResPath,databaseLmpDir);
    RefreshF;
  end;
end;

procedure TIshF.FullGetBaseButClick(Sender: TObject);
begin
  ShowMess := false;
  UnPackBasButClick(Sender);
  KlepIshButClick(Sender);
  ShowMess := true;
end;

procedure TIshF.FullGetLmpBaseButClick(Sender: TObject);
begin
  ShowMess := false;
  UnPackLmpBasButClick(Sender);
  KlepIshLmpButClick(Sender);
  ShowMess := true;
end;

procedure TIshF.FullMakeBaseButClick(Sender: TObject);
begin
  if messageDLG('  '+ExtractFileName(DatabaseResPath)+'     ?',mtWarning,[mbYes]+[mbNo],0) = mrYes then begin
    ShowMess := false;
    DelBaseButClick(Sender);
    ResbildnutBaseButClick(Sender);
    ShowMess := true;
  end;
end;

procedure TIshF.FullMakeLmpBaseButClick(Sender: TObject);
begin
  if messageDLG('  '+ExtractFileName(DatabaselmpResPath)+'     ?',mtWarning,[mbYes]+[mbNo],0) = mrYes then begin
    ShowMess := false;
    DelBaseLmpButClick(Sender);
    ResbildnutBaseLmpButClick(Sender);
    ShowMess := true;
  end;
end;

end.
