///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit NewFilterAskForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TNewFilterAskF = class(TForm)
    Label1: TLabel;
    FilterEd: TEdit;
    Label2: TLabel;
    FilterDescEd: TEdit;
    OkBut: TButton;
    CancelBut: TButton;
    procedure OkButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewFilterAskF: TNewFilterAskF;

implementation
uses TextEdForm;

{$R *.dfm}

procedure TNewFilterAskF.OkButClick(Sender: TObject);
begin
  If (TextEdF.CheckFilterExists(FilterEd.Text) = 0) and (FilterEd.Text <> '') then begin
    //   :)
    ModalResult := mrOk;
  end
  else begin
    // .
    If TextEdF.CheckFilterExists(FilterEd.Text) <> 0 then begin
      MessageBox(Application.Handle,'!    ! ;)','!!',MB_ICONWARNING or MB_OK);
    end
    else begin
      MessageBox(Application.Handle,' !','!!',MB_ICONWARNING or MB_OK);
    end;
  end;
end;

procedure TNewFilterAskF.CancelButClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TNewFilterAskF.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //ShowMessage('');   //      watch-,  .

  //       :).
  If Key = #13 then begin
    //Enter
    OkButClick(Sender);
    //    ...
    Key := #0;
  end;

  If Key = #27 then begin
    //Escape
    CancelButClick(Sender);
    //    ...
    Key := #0;
  end;
end;

end.
