///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit SinglUnitsUdbR2Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TSinglUnitsUdbR2F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  SinglUnitsUdbR2F: TSinglUnitsUdbR2F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, Unknown2, Unknown3, Unknown4, Unknown5,
  Unknown6, Unknown7, Unknown8, Unknown9, Unknown10 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz, Unk3Siz, Unk4Siz, Unk5Siz,
  Unk6Siz, Unk7Siz, Unk8Siz, Unk9Siz, Unk10Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TSinglUnitsUdbR2F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  SinglUnitsUdbR2FClosed := true;
  MainForm.UnitsMenu2.Checked := false;
  Action := CaFree;
end;

procedure TSinglUnitsUdbR2F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  SinglUnitsUdbR2FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';
  ValuesEd.Cells[1,24] := '';
  ValuesEd.Cells[1,25] := '';
  ValuesEd.Cells[1,26] := '';
  ValuesEd.Cells[1,27] := '';
  ValuesEd.Cells[1,28] := '';
  ValuesEd.Cells[1,29] := '';
  ValuesEd.Cells[1,30] := '';
  ValuesEd.Cells[1,31] := '';
  ValuesEd.Cells[1,32] := '';
  ValuesEd.Cells[1,33] := '';
  ValuesEd.Cells[1,34] := '';
  ValuesEd.Cells[1,35] := '';
  ValuesEd.Cells[1,36] := '';
  ValuesEd.Cells[1,37] := '';
  ValuesEd.Cells[1,38] := '';
  ValuesEd.Cells[1,39] := '';
  ValuesEd.Cells[1,40] := '';
  ValuesEd.Cells[1,41] := '';
  ValuesEd.Cells[1,42] := '';
  ValuesEd.Cells[1,43] := '';
  ValuesEd.Cells[1,44] := '';
  ValuesEd.Cells[1,45] := '';
  ValuesEd.Cells[1,46] := '';
  ValuesEd.Cells[1,47] := '';
  ValuesEd.Cells[1,48] := '';
  ValuesEd.Cells[1,49] := '';
  ValuesEd.Cells[1,50] := '';
  ValuesEd.Cells[1,51] := '';
  ValuesEd.Cells[1,52] := '';
  ValuesEd.Cells[1,53] := '';
  ValuesEd.Cells[1,54] := '';
  ValuesEd.Cells[1,55] := '';
  ValuesEd.Cells[1,56] := '';
  ValuesEd.Cells[1,57] := '';
  ValuesEd.Cells[1,58] := '';
  ValuesEd.Cells[1,59] := '';
  ValuesEd.Cells[1,60] := '';
  ValuesEd.Cells[1,61] := '';
  ValuesEd.Cells[1,62] := '';
  ValuesEd.Cells[1,63] := '';
  ValuesEd.Cells[1,64] := '';
  ValuesEd.Cells[1,65] := '';
  ValuesEd.Cells[1,66] := '';
  ValuesEd.Cells[1,67] := '';
  ValuesEd.Cells[1,68] := '';
  ValuesEd.Cells[1,69] := '';
  ValuesEd.Cells[1,70] := '';
  ValuesEd.Cells[1,71] := '';
  ValuesEd.Cells[1,72] := '';
  ValuesEd.Cells[1,73] := '';
  ValuesEd.Cells[1,74] := '';
  ValuesEd.Cells[1,75] := '';
  ValuesEd.Cells[1,76] := '';
  ValuesEd.Cells[1,77] := '';
  ValuesEd.Cells[1,78] := '';
  ValuesEd.Cells[1,79] := '';
  ValuesEd.Cells[1,80] := '';
  ValuesEd.Cells[1,81] := '';
  ValuesEd.Cells[1,82] := '';
  ValuesEd.Cells[1,83] := '';
  ValuesEd.Cells[1,84] := '';
  ValuesEd.Cells[1,85] := '';
  ValuesEd.Cells[1,86] := '';
  ValuesEd.Cells[1,87] := '';
  ValuesEd.Cells[1,88] := '';
  ValuesEd.Cells[1,89] := '';
  ValuesEd.Cells[1,90] := '';
  ValuesEd.Cells[1,91] := '';
  ValuesEd.Cells[1,92] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaseResIsh;     //  
  PathForForm := IshDir+'units\2\';     //   
  ShablonsPath := Path+'shablons\units\2\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TSinglUnitsUdbR2F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TSinglUnitsUdbR2F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TSinglUnitsUdbR2F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //TypeID -  2  UnsLong. - ID.  -...
  BufSt :=  IntToStr(_4byteStrToUnsLong(Zap1.GetField(2)));
  If BufSt = '50' then begin
    BufSt := BufSt+'     HUMAN';
  end;
  If BufSt = '51' then begin
    BufSt := BufSt+'     MONSTER';
  end;
  If BufSt = '52' then begin
    BufSt := BufSt+'     ANIMAL';
  end;
  ValuesEd.Cells[1,2] := BufSt;

  //Regenerate Health -  3  FLOAT.
  ValuesEd.Cells[1,3] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(3)),7));

  //Regenerate Mana -  3  FLOAT.
  ValuesEd.Cells[1,4] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(4)),7));

  //SecondaryLanguage -  5  UnsLong.
  ValuesEd.Cells[1,5] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(5)));

  //SecondaryLocomotion -  6  UnsLong.
  ValuesEd.Cells[1,6] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(6)));

  //Secondary Vision arc -  7  FLOAT.
  ValuesEd.Cells[1,7] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(7)),7));

  //Speed -  8   -    , 4 FLOAT .
  BufSt := Zap1.GetField(8);
  //Speed Run. FLOAT. -  1.
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Speed Walk. FLOAT. -  2.
  ValuesEd.Cells[1,9] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Speed Sneak. FLOAT. -  3.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Speed Crawl. FLOAT. -  4.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //AttackDistance -  9  FLOAT.
  ValuesEd.Cells[1,12] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(9)),7));

  //AI Class Stay -  10  UnsLong.
  ValuesEd.Cells[1,13] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(10)));

  //AI Class Lie -  11  UnsLong.
  ValuesEd.Cells[1,14] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(11)));

  //Attack -  12   -    , 7 FLOAT .
  BufSt := Zap1.GetField(12);
  //Attack Piercing. FLOAT. -  1.
  ValuesEd.Cells[1,15] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Attack Slashing. FLOAT. -  2.
  ValuesEd.Cells[1,16] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Attack Bludgeoning. FLOAT. -  3.
  ValuesEd.Cells[1,17] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Attack Termal. FLOAT. -  4.
  ValuesEd.Cells[1,18] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Attack Chemic. FLOAT. -  5.
  ValuesEd.Cells[1,19] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Attack Electric. FLOAT. -  6.
  ValuesEd.Cells[1,20] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Attack General. FLOAT. -  7.
  ValuesEd.Cells[1,21] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Head -  13. .   0  3. (4 ).
  BufSt := Zap1.GetField(13);
  //HL HeadType. TEXT. -  0.
  ValuesEd.Cells[1,22] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Unknown1 -  1  UnsLong.
  ValuesEd.Cells[1,23] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //HL Head Weigth -  2  FLOAT.
  ValuesEd.Cells[1,24] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //HL Head Vitality -  3  FLOAT.
  ValuesEd.Cells[1,25] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Torso -  14. .   0  3. (4 ).
  BufSt := Zap1.GetField(14);
  //HL TorsoType. TEXT. -  0.
  ValuesEd.Cells[1,26] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Unknown2 -  1  UnsLong.
  ValuesEd.Cells[1,27] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //HL Torso Weigth -  2  FLOAT.
  ValuesEd.Cells[1,28] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //HL Torso Vitality -  3  FLOAT.
  ValuesEd.Cells[1,29] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Rigth Arm -  15. .   0  3. (4 ).
  BufSt := Zap1.GetField(15);
  //HL Rigth Arm Type. TEXT. -  0.
  ValuesEd.Cells[1,30] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Unknown3 -  1  UnsLong.
  ValuesEd.Cells[1,31] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //HL Rigth Arm Weigth -  2  FLOAT.
  ValuesEd.Cells[1,32] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //HL Rigth Arm Vitality -  3  FLOAT.
  ValuesEd.Cells[1,33] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Left Arm -  16. .   0  3. (4 ).
  BufSt := Zap1.GetField(16);
  //HL Left Arm Type. TEXT. -  0.
  ValuesEd.Cells[1,34] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Unknown4 -  1  UnsLong.
  ValuesEd.Cells[1,35] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //HL Left Arm Weigth -  2  FLOAT.
  ValuesEd.Cells[1,36] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //HL Left Arm Vitality -  3  FLOAT.
  ValuesEd.Cells[1,37] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Rigth Leg -  17. .   0  3. (4 ).
  BufSt := Zap1.GetField(17);
  //HL Rigth Leg Type. TEXT. -  0.
  ValuesEd.Cells[1,38] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Unknown5 -  1  UnsLong.
  ValuesEd.Cells[1,39] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //HL Rigth Leg Weigth -  2  FLOAT.
  ValuesEd.Cells[1,40] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //HL Rigth Leg Vitality -  3  FLOAT.
  ValuesEd.Cells[1,41] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Left Leg -  18. .   0  3. (4 ).
  BufSt := Zap1.GetField(18);
  //HL Left Leg Type. TEXT. -  0.
  ValuesEd.Cells[1,42] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Unknown6 -  1  UnsLong.
  ValuesEd.Cells[1,43] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //HL Left Leg Weigth -  2  FLOAT.
  ValuesEd.Cells[1,44] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //HL Left Leg Vitality -  3  FLOAT.
  ValuesEd.Cells[1,45] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Graphics data Mask name -  19  TEXT.
  ValuesEd.Cells[1,46] := PzDbStrToStr(Zap1.GetField(19));

  //Graphics data Primary textures -  20  List.
  ValuesEd.Cells[1,47] := ListToStr(Zap1.GetField(20));

  //Graphics data Secondary textures -  21  List.
  ValuesEd.Cells[1,48] := ListToStr(Zap1.GetField(21));

  //Graphic data Model Shift -  22  FLOAT*-1.
  ValuesEd.Cells[1,49] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(22))*-1,7));

  //Sounds data SFX Path -  23  TEXT.
  ValuesEd.Cells[1,50] := PzDbStrToStr(Zap1.GetField(23));

  //Sounds data Steps -  24. List.    1. (16 ).
  BufSt := Zap1.GetField(24);
  //Sounds data Steps grass. TEXT. -  1.
  ValuesEd.Cells[1,51] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps ground. TEXT. -  2.
  ValuesEd.Cells[1,52] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps stone. TEXT. -  3.
  ValuesEd.Cells[1,53] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps sand. TEXT. -  4.
  ValuesEd.Cells[1,54] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps rock. TEXT. -  5.
  ValuesEd.Cells[1,55] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps field. TEXT. -  6.
  ValuesEd.Cells[1,56] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps water. TEXT. -  7.
  ValuesEd.Cells[1,57] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps road. TEXT. -  8.
  ValuesEd.Cells[1,58] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps snow. TEXT. -  9.
  ValuesEd.Cells[1,59] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps snow. TEXT. -  10.
  ValuesEd.Cells[1,60] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps ice. TEXT. -  11.
  ValuesEd.Cells[1,61] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps drygrass. TEXT. -  12.
  ValuesEd.Cells[1,62] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps snowballs. TEXT. -  13.
  ValuesEd.Cells[1,63] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps lava. TEXT. -  14.
  ValuesEd.Cells[1,64] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps swamp. TEXT. -  15.
  ValuesEd.Cells[1,65] := PzDbStrToStr(OtkusitPodPole(@BufSt));
  //Sounds data Steps highrock. TEXT. -  16.
  ValuesEd.Cells[1,66] := PzDbStrToStr(OtkusitPodPole(@BufSt));

  //Animation -  25   -    , 6 FLOAT .
  BufSt := Zap1.GetField(25);
  //Animation Speed Attack. FLOAT. -  1.
  ValuesEd.Cells[1,67] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Animation Speed Cast. FLOAT. -  2.
  ValuesEd.Cells[1,68] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Animation Speed Hit. FLOAT. -  3.
  ValuesEd.Cells[1,69] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Animation Speed Death. FLOAT. -  4.
  ValuesEd.Cells[1,70] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Animation Speed Cross. FLOAT. -  5.
  ValuesEd.Cells[1,71] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Animation Speed Special. FLOAT. -  6.
  ValuesEd.Cells[1,72] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Sounds Probability Idle -  26  UnsLong.
  ValuesEd.Cells[1,73] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(26)));

  //Sounds Probability Attack -  27  UnsLong.
  ValuesEd.Cells[1,74] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(27)));

  //Defence -  28   -    , 7 FLOAT .
  BufSt := Zap1.GetField(28);
  //Defence Piercing. FLOAT. -  1.
  ValuesEd.Cells[1,75] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Defence Slashing. FLOAT. -  2.
  ValuesEd.Cells[1,76] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Defence Bludgeoning. FLOAT. -  3.
  ValuesEd.Cells[1,77] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Defence Termal. FLOAT. -  4.
  ValuesEd.Cells[1,78] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Defence Chemic. FLOAT. -  5.
  ValuesEd.Cells[1,79] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Defence Electric. FLOAT. -  6.
  ValuesEd.Cells[1,80] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Defence General. FLOAT. -  7.
  ValuesEd.Cells[1,81] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Graphics data Blood type -  29  UnsLong.
  ValuesEd.Cells[1,82] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(29)));

  //Graphics data Cast Type -  30  UnsLong.
  ValuesEd.Cells[1,83] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(30)));

  //Graphics data Footprint Type -  31  UnsLong+1.
  ValuesEd.Cells[1,84] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(31))+1);

  //Graphics data Leg Segments -  32  UnsLong.
  ValuesEd.Cells[1,85] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(32)));

  //Graphics data Native Skin Type -  33  TEXT.
  ValuesEd.Cells[1,86] := PzDbStrToStr(Zap1.GetField(33));

  //Graphics data First Step Right -  34  BOOLEAN.
  ValuesEd.Cells[1,87] := BoolToStr(_1byteStrToBool(Zap1.GetField(34)));

  //Graphics data HeadHeight -  35  FLOAT.
  ValuesEd.Cells[1,88] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(35)),7));

  //Unknown7 -  36  UnsLong.
  ValuesEd.Cells[1,89] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(36)));

  //Unknown8 -  37  UnsLong.
  ValuesEd.Cells[1,90] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(37)));

  //Unknown7 -  38  UnsLong.
  ValuesEd.Cells[1,91] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(38)));

  //Unknown7 -  39  UnsLong.
  ValuesEd.Cells[1,92] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(39)));

end;

Function TSinglUnitsUdbR2F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrInt(FilterValue(ValuesEd.Cells[1,2])) = false then begin
    AllOk := false;
    //TypeID.    !!!
    ValuesEd.Selection := SelGridRect(1,2);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Regenerate Health
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Regenerate Mana
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //SecondaryLanguage
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //SecondaryLocomotion
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Secondary Vision arc
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //Speed Run
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,9]) = false then begin
    AllOk := false;
    //Speed Walk
    ValuesEd.Selection := SelGridRect(1,9);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Speed Sneak
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Speed Crawl
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //AttackDistance
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //AI Class Stay
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //AI Class Lie
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Attack Piercing
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Attack Slashing
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Attack Bludgeoning
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Attack Termal
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,19]) = false then begin
    AllOk := false;
    //Attack Chemic
    ValuesEd.Selection := SelGridRect(1,19);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,20]) = false then begin
    AllOk := false;
    //Attack Electric
    ValuesEd.Selection := SelGridRect(1,20);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,21]) = false then begin
    AllOk := false;
    //Attack General
    ValuesEd.Selection := SelGridRect(1,21);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,23]) = false then begin
    AllOk := false;
    //Unknown1
    ValuesEd.Selection := SelGridRect(1,23);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,24]) = false then begin
    AllOk := false;
    //HL Head Weigth
    ValuesEd.Selection := SelGridRect(1,24);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,25]) = false then begin
    AllOk := false;
    //HL Head Vitality
    ValuesEd.Selection := SelGridRect(1,25);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,27]) = false then begin
    AllOk := false;
    //Unknown2
    ValuesEd.Selection := SelGridRect(1,27);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,28]) = false then begin
    AllOk := false;
    //HL Torso Weigth
    ValuesEd.Selection := SelGridRect(1,28);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,29]) = false then begin
    AllOk := false;
    //HL Torso Vitality
    ValuesEd.Selection := SelGridRect(1,29);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,31]) = false then begin
    AllOk := false;
    //Unknown3
    ValuesEd.Selection := SelGridRect(1,31);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,32]) = false then begin
    AllOk := false;
    //HL Rigth Arm Weigth
    ValuesEd.Selection := SelGridRect(1,32);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,33]) = false then begin
    AllOk := false;
    //HL Rigth Arm Vitality
    ValuesEd.Selection := SelGridRect(1,33);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,35]) = false then begin
    AllOk := false;
    //Unknown4
    ValuesEd.Selection := SelGridRect(1,35);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,36]) = false then begin
    AllOk := false;
    //HL Left Arm Weigth
    ValuesEd.Selection := SelGridRect(1,36);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,37]) = false then begin
    AllOk := false;
    //HL Left Arm Vitality
    ValuesEd.Selection := SelGridRect(1,37);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,39]) = false then begin
    AllOk := false;
    //Unknown5
    ValuesEd.Selection := SelGridRect(1,39);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,40]) = false then begin
    AllOk := false;
    //HL Rigth Leg Weigth
    ValuesEd.Selection := SelGridRect(1,40);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,41]) = false then begin
    AllOk := false;
    //HL Rigth Leg Vitality
    ValuesEd.Selection := SelGridRect(1,41);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,43]) = false then begin
    AllOk := false;
    //Unknown6
    ValuesEd.Selection := SelGridRect(1,43);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,44]) = false then begin
    AllOk := false;
    //HL Left Leg Weigth
    ValuesEd.Selection := SelGridRect(1,44);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,45]) = false then begin
    AllOk := false;
    //HL Left Leg Vitality
    ValuesEd.Selection := SelGridRect(1,45);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckList(ValuesEd.Cells[1,47]) = false then begin
    AllOk := false;
    //Graphics data Primary textures
    ValuesEd.Selection := SelGridRect(1,47);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,47] := ListBezProbelov(ValuesEd.Cells[1,47]);
    if CheckList(ValuesEd.Cells[1,47]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,47);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckList(ValuesEd.Cells[1,48]) = false then begin
    AllOk := false;
    //Graphics data Secondary textures
    ValuesEd.Selection := SelGridRect(1,48);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,48] := ListBezProbelov(ValuesEd.Cells[1,48]);
    if CheckList(ValuesEd.Cells[1,48]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,48);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,49]) = false then begin
    AllOk := false;
    //Graphic data Model Shift
    ValuesEd.Selection := SelGridRect(1,49);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,67]) = false then begin
    AllOk := false;
    //Animation Speed Attack
    ValuesEd.Selection := SelGridRect(1,67);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,68]) = false then begin
    AllOk := false;
    //Animation Speed Cast
    ValuesEd.Selection := SelGridRect(1,68);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,69]) = false then begin
    AllOk := false;
    //Animation Speed Hit
    ValuesEd.Selection := SelGridRect(1,69);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,70]) = false then begin
    AllOk := false;
    //Animation Speed Death
    ValuesEd.Selection := SelGridRect(1,70);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,71]) = false then begin
    AllOk := false;
    //Animation Speed Cross
    ValuesEd.Selection := SelGridRect(1,71);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,72]) = false then begin
    AllOk := false;
    //Animation Speed Special
    ValuesEd.Selection := SelGridRect(1,72);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,73]) = false then begin
    AllOk := false;
    //Sounds Probability Idle
    ValuesEd.Selection := SelGridRect(1,73);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,74]) = false then begin
    AllOk := false;
    //Sounds Probability Attack
    ValuesEd.Selection := SelGridRect(1,74);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,75]) = false then begin
    AllOk := false;
    //Defence Piercing
    ValuesEd.Selection := SelGridRect(1,75);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,76]) = false then begin
    AllOk := false;
    //Defence Slashing
    ValuesEd.Selection := SelGridRect(1,76);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,77]) = false then begin
    AllOk := false;
    //Defence Bludgeoning
    ValuesEd.Selection := SelGridRect(1,77);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,78]) = false then begin
    AllOk := false;
    //Defence Termal
    ValuesEd.Selection := SelGridRect(1,78);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,79]) = false then begin
    AllOk := false;
    //Defence Chemic
    ValuesEd.Selection := SelGridRect(1,79);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,80]) = false then begin
    AllOk := false;
    //Defence Electric
    ValuesEd.Selection := SelGridRect(1,80);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,81]) = false then begin
    AllOk := false;
    //Defence General
    ValuesEd.Selection := SelGridRect(1,81);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,82]) = false then begin
    AllOk := false;
    //Graphics data Blood type
    ValuesEd.Selection := SelGridRect(1,82);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,83]) = false then begin
    AllOk := false;
    //Graphics data Cast Type
    ValuesEd.Selection := SelGridRect(1,83);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,84]) = false then begin
    AllOk := false;
    //Graphics data Footprint Type
    ValuesEd.Selection := SelGridRect(1,84);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,85]) = false then begin
    AllOk := false;
    //Graphics data Leg Segments
    ValuesEd.Selection := SelGridRect(1,85);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrBool(ValuesEd.Cells[1,87]) = false then begin
    AllOk := false;
    //Graphics data First Step Right
    ValuesEd.Selection := SelGridRect(1,87);
    ErrorMsgStr := '    .   -  "",   -  "" ( 0=False, 1=True)';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,88]) = false then begin
    AllOk := false;
    //Graphics data HeadHeight
    ValuesEd.Selection := SelGridRect(1,88);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,89]) = false then begin
    AllOk := false;
    //Unknown7
    ValuesEd.Selection := SelGridRect(1,89);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,90]) = false then begin
    AllOk := false;
    //Unknown8
    ValuesEd.Selection := SelGridRect(1,90);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,91]) = false then begin
    AllOk := false;
    //Unknown9
    ValuesEd.Selection := SelGridRect(1,91);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,92]) = false then begin
    AllOk := false;
    //Unknown10
    ValuesEd.Selection := SelGridRect(1,92);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,1]);
    Zap1.ReWriteField(1,Length(BufSt),BufSt);

    //TypeID.  2. UnsLong.    .
    Zap1.ReWriteField(2,4,UnsLongTo4byteStr(StrToInt(FilterValue(ValuesEd.Cells[1,2]))));

    //Regenerate Health.  3. FLOAT.
    Zap1.ReWriteField(3,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,3])));

    //Regenerate Mana.  4. FLOAT.
    Zap1.ReWriteField(4,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,4])));

    //SecondaryLanguage.  5. UnsLong.
    Zap1.ReWriteField(5,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,5])));

    //SecondaryLocomotion.  6. UnsLong.
    Zap1.ReWriteField(6,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,6])));

    //Secondary Vision arc.  7. FLOAT.
    Zap1.ReWriteField(7,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,7])));

    //Speed.  8. 4 FLOAT .
    BufSt := '';
    //Speed Run
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8]));
    //Speed Walk
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,9]));
    //Speed Sneak
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10]));
    //Speed Crawl
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11]));
    Zap1.ReWriteField(8,16,BufSt);

    //AttackDistance.  9. FLOAT.
    Zap1.ReWriteField(9,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,12])));

    //AI Class Stay.  10. UnsLong.
    Zap1.ReWriteField(10,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,13])));

    //AI Class Lie.  11. UnsLong.
    Zap1.ReWriteField(11,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,14])));

    //Attack.  12. 7 FLOAT .
    BufSt := '';
    //Attack Piercing
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,15]));
    //Attack Slashing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,16]));
    //Attack Bludgeoning
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,17]));
    //Attack Termal
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,18]));
    //Attack Chemic
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,19]));
    //Attack Electric
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,20]));
    //Attack General
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,21]));
    Zap1.ReWriteField(12,28,BufSt);

    //Head.  13. .   0  3 (4 ).
    BufSt := '';
    //HL HeadType. TEXT. -  0.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,22]),0);
    //Unknown1. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,23])),1);
    //HL Head Weigth. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,24])),2);
    //HL Head Vitality. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,25])),3);
    //  ...
    Zap1.ReWriteField(13,Length(BufSt),BufSt);

    //Torso.  14. .   0  3 (4 ).
    BufSt := '';
    //HL TorsoType. TEXT. -  0.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,26]),0);
    //Unknown2. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,27])),1);
    //HL Torso Weigth. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,28])),2);
    //HL Torso Vitality. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,29])),3);
    //  ...
    Zap1.ReWriteField(14,Length(BufSt),BufSt);

    //Rigth Arm.  15. .   0  3 (4 ).
    BufSt := '';
    //HL Rigth Arm Type. TEXT. -  0.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,30]),0);
    //Unknown3. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,31])),1);
    //HL Rigth Arm Weigth. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,32])),2);
    //HL Rigth Arm Vitality. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,33])),3);
    //  ...
    Zap1.ReWriteField(15,Length(BufSt),BufSt);

    //Left Arm.  16. .   0  3 (4 ).
    BufSt := '';
    //HL Left Arm Type. TEXT. -  0.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,34]),0);
    //Unknown4. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,35])),1);
    //HL Left Arm Weigth. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,36])),2);
    //HL Left Arm Vitality. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,37])),3);
    //  ...
    Zap1.ReWriteField(16,Length(BufSt),BufSt);

    //Rigth Leg.  17. .   0  3 (4 ).
    BufSt := '';
    //HL Rigth Leg Type. TEXT. -  0.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,38]),0);
    //Unknown5. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,39])),1);
    //HL Rigth Leg Weigth. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,40])),2);
    //HL Rigth Leg Vitality. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,41])),3);
    //  ...
    Zap1.ReWriteField(17,Length(BufSt),BufSt);

    //Left Leg.  18. .   0  3 (4 ).
    BufSt := '';
    //HL Left Leg Type. TEXT. -  0.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,42]),0);
    //Unknown6. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,43])),1);
    //HL Left Leg Weigth. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,44])),2);
    //HL Left Leg Vitality. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,45])),3);
    //  ...
    Zap1.ReWriteField(18,Length(BufSt),BufSt);

    //Graphics data Mask name.  19. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,46]);
    Zap1.ReWriteField(19,Length(BufSt),BufSt);

    //Graphics data Primary textures.  20. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,47]);
    Zap1.ReWriteField(20,Length(BufSt),BufSt);

    //Graphics data Secondary textures.  21. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,48]);
    Zap1.ReWriteField(21,Length(BufSt),BufSt);

    //Graphic data Model Shift.  22. FLOAT*-1.
    Zap1.ReWriteField(22,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,49])*-1));

    //Sounds data SFX Path.  23. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,50]);
    Zap1.ReWriteField(23,Length(BufSt),BufSt);

    //Sounds.  24. .  LIST,      . 16 .
    BufSt := '';
    //Sounds data Steps grass. TEXT. -  1.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,51]),1);
    //Sounds data Steps ground. TEXT. -  2.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,52]),1);
    //Sounds data Steps stone. TEXT. -  3.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,53]),1);
    //Sounds data Steps sand. TEXT. -  4.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,54]),1);
    //Sounds data Steps rock. TEXT. -  5.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,55]),1);
    //Sounds data Steps field. TEXT. -  6.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,56]),1);
    //Sounds data Steps water. TEXT. -  7.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,57]),1);
    //Sounds data Steps road. TEXT. -  8.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,58]),1);
    //Sounds data Steps UNKNOWN. TEXT. -  9.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,59]),1);
    //Sounds data Steps snow. TEXT. -  10.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,60]),1);
    //Sounds data Steps ice. TEXT. -  11.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,61]),1);
    //Sounds data Steps drygrass. TEXT. -  12.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,62]),1);
    //Sounds data Steps snowballs. TEXT. -  13.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,63]),1);
    //Sounds data Steps lava. TEXT. -  14.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,64]),1);
    //Sounds data Steps swamp. TEXT. -  15.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,65]),1);
    //Sounds data Steps highrock. TEXT. -  16.
    BufSt := AddPodPole(BufSt,StrToPzDbStr2(ValuesEd.Cells[1,66]),1);
    //  ...
    Zap1.ReWriteField(24,Length(BufSt),BufSt);

    //Animation.  25. 6 FLOAT .
    BufSt := '';
    //Animation Speed Attack
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,67]));
    //Animation Speed Cast
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,68]));
    //Animation Speed Hit
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,69]));
    //Animation Speed Death
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,70]));
    //Animation Speed Cross
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,71]));
    //Animation Speed Special
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,72]));
    //  ...
    Zap1.ReWriteField(25,24,BufSt);

    //Sounds Probability Idle.  26. UnsLong.
    Zap1.ReWriteField(26,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,73])));

    //Sounds Probability Attack.  27. UnsLong.
    Zap1.ReWriteField(27,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,74])));

    //Defence.  28. 7 FLOAT .
    BufSt := '';
    //Defence Piercing
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,75]));
    //Defence Slashing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,76]));
    //Defence Bludgeoning
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,77]));
    //Defence Termal
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,78]));
    //Defence Chemic
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,79]));
    //Defence Electric
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,80]));
    //Defence General
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,81]));
    //  ...
    Zap1.ReWriteField(28,28,BufSt);

    //Graphics data Blood type.  29. UnsLong.
    Zap1.ReWriteField(29,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,82])));

    //Graphics data Cast Type.  30. UnsLong.
    Zap1.ReWriteField(30,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,83])));

    //Graphics data Footprint Type.  31. UnsLong+1.
    Zap1.ReWriteField(31,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,84])-1));

    //Graphics data Leg Segments.  32. UnsLong.
    Zap1.ReWriteField(32,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,85])));

    //Graphics data Native Skin Type.  33. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,86]);
    Zap1.ReWriteField(33,Length(BufSt),BufSt);

    //Graphics data First Step Right.  34. BOOLEAN.
    Zap1.ReWriteField(34,1,BoolTo1byteStr(StrToBool(ValuesEd.Cells[1,87])));

    //Graphics data HeadHeight.  35. FLOAT.
    Zap1.ReWriteField(35,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,88])));

    //Unknown7.  36. UnsLong.
    Zap1.ReWriteField(36,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,89])));

    //Unknown8.  37. UnsLong.
    Zap1.ReWriteField(37,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,90])));

    //Unknown9.  38. UnsLong.
    Zap1.ReWriteField(38,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,91])));

    //Unknown10.  39. UnsLong.
    Zap1.ReWriteField(39,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,92])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TSinglUnitsUdbR2F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[1].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TSinglUnitsUdbR2F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[1].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to SinglUnitsUdbR2F.MaskiBox.Items.Capacity-1 do begin
    If SinglUnitsUdbR2F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to SinglUnitsUdbR2F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If SinglUnitsUdbR2F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TSinglUnitsUdbR2F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TSinglUnitsUdbR2F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TSinglUnitsUdbR2F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TSinglUnitsUdbR2F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TSinglUnitsUdbR2F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TSinglUnitsUdbR2F.ValuesEdEditButtonClick(Sender: TObject);
var
  BufSt : string;
  Idx : Integer;
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 2 then begin
      //       ...
      //  -  ...
      Idx := 0; //  ....
      If FilterValue(ValuesEd.Cells[1,2]) = '50' then begin
        Idx := 0;
      end;
      If FilterValue(ValuesEd.Cells[1,2]) = '51' then begin
        Idx := 1;
      end;
      If FilterValue(ValuesEd.Cells[1,2]) = '52' then begin
        Idx := 2;
      end;
      BufSt := SelectValueEx('50     HUMAN'+#13+'51     MONSTER'+#13+'52     ANIMAL'+#13,Idx);
      If BufSt <> #13 then begin
        //    ...
        ValuesEd.Cells[1,2] := BufSt;
      end;
    end;

  end;
end;

procedure TSinglUnitsUdbR2F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
