///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit UncAskForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, initer, MySys, KOLFileInString;

type
  TUncAskF = class(TForm)
    InfoLab: TLabel;
    SaveRB: TRadioButton;
    LoadRB: TRadioButton;
    OkBut: TButton;
    CancelBut: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure OkButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    UncAskFBuff : string;
    UncAskFBytes : integer;
  end;

var
  UncAskF: TUncAskF;

implementation

{$R *.dfm}

procedure TUncAskF.FormShow(Sender: TObject);
begin
  //    

  //   .
  InfoLab.Caption := '  '+IntToStr(UncAskFBytes)+' ';
end;

procedure TUncAskF.OkButClick(Sender: TObject);
var
  AllOk : boolean;
  Fil1 : TFileInString;
  F1 : file;
  FSiz : int64;
begin
  //  .
  AllOk := true;
  //    
  //   .
  If SaveRB.Checked = true then UncAskFSaved := true
  else UncAskFSaved := false;

  //     ...
  If UncAskFSaved = true then begin
    //...
    // ...
    SaveDialog1.InitialDir := DefalDir;
    If SaveDialog1.Execute then begin
      //  ""   .
      //      .
      Fil1 := TFileInString.Init;
      Fil1.MakNewFile;
      Fil1.FileString := UncAskFBuff;
      //Fil1.Siz := UncAskFBytes;
      Fil1.Save(SaveDialog1.FileName);
      Fil1.Free;

      //    DefalDir
      DefalDir := GetFilePath(SaveDialog1.FileName);
      AnIniFil.Load(IniFilPath);  // .
      AnIniFil.WriteString('MainSettings','DefalDir',DefalDir);
      AnIniFil.Save(IniFilPath);  // .    :)
    end
    else begin
      //    .
      AllOk := false;
    end;
  end
  else begin
    //...
    // .
    OpenDialog1.InitialDir := DefalDir;
    If OpenDialog1.Execute then begin
      //     
      //     ,   .
      //     .
      //      
      //  .

      // - 1)   -    
      //   -  ...

      AssignFile(F1,OpenDialog1.FileName);
      reset(F1,1);
      FSiz := FileSize(F1);   //  .
      CloseFile(F1);
      If FSiz = UncAskFBytes then begin
        // ...
        Fil1 := TFileInString.Init;
        Fil1.Load(OpenDialog1.FileName);
        UncAskFBuff := Fil1.FileString;
        UncAskFBytes := Fil1.Siz;
        Fil1.Free;
        AllOk := true;
      end
      else begin
        //   .

        //      
        //,    ( ).

        If UncAskFLetChangSiz = false then begin
          MessageDLG('.    '+IntToStr(FSiz)+' ,'+#13+'      '+IntToStr(UncAskFBytes)+' .      .'+#13+'  !',mtError,[mbOk],0);
          AllOk := false;
        end
        else begin
          //.
          If MessageDLG('!      '+IntToStr(FSiz)+' ,'+#13+'      '+IntToStr(UncAskFBytes)+' .   ?',mtWarning,[mbYes]+[mbNo],0) = mrYes then begin
            // ...
            Fil1 := TFileInString.Init;
            Fil1.Load(OpenDialog1.FileName);
            UncAskFBuff := Fil1.FileString;
            UncAskFBytes := Fil1.Siz;
            Fil1.Free;
            AllOk := true;
          end
          else begin
            // 
            AllOk := false;
          end;
        end;
      end;

      //    DefalDir
      DefalDir := GetFilePath(OpenDialog1.FileName);
      AnIniFil.Load(IniFilPath);  // .
      AnIniFil.WriteString('MainSettings','DefalDir',DefalDir);
      AnIniFil.Save(IniFilPath);  // .    :)
    end
    else begin
      //    .
      AllOk := false;
    end;
  end;

  If AllOk = true then ModalResult := mrOk;
end;

procedure TUncAskF.CancelButClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
