///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit UnitsUdbR3Form;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, initer, KOLClearDir, mySys, Grids, ValEdit, KOLFileInString;

type
  TUnitsUdbR3F = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    MaskiBox: TComboBox;
    FilesBox: TComboBox;
    SaveBut: TButton;
    CloseBut: TButton;
    CreateBut: TButton;
    DeleteBut: TButton;
    ValuesEd: TValueListEditor;
    ZashablonitBut: TButton;
    SortBut: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MaskiBoxClick(Sender: TObject);
    procedure FilesBoxClick(Sender: TObject);
    Procedure LoadFil(const FilNam : string; Sender: TObject);
    Function GenZap(Sender : TObject): boolean;
    Procedure ActivateTable(Sender : TObject);
    Procedure DeActivateTable(Sender : TObject);
    procedure ZashablonitButClick(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CreateButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ValuesEdEditButtonClick(Sender: TObject);
    procedure SortButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Function CheckMaska(const Maska : string) : boolean;
Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;

var
  UnitsUdbR3F: TUnitsUdbR3F;
  PathForForm, MaskaNam, FileNam, ShablonsPath,
  Unknown1, Unknown2 : String;
  Indeks : MaskFileArr;
  Fil1 : TFileInString;
  Zap1 : TZapisBaziPZ;
  FileLoaded, TableActivated : boolean;
  Unk1Siz, Unk2Siz : integer;

implementation

uses PZed, ShablonimForm, QskFnForm, CheckShablForm, UncAskForm;

{$R *.dfm}

procedure TUnitsUdbR3F.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Fil1.Free;
  Zap1.Free;
  UnitsUdbR3FClosed := true;
  MainForm.LmpUnitsMenu3.Checked := false;
  Action := CaFree;
end;

procedure TUnitsUdbR3F.FormShow(Sender: TObject);
var
  I, J, Num : integer;
  FailEst : boolean;
  resSt : string;
begin
  Cascade;
  UnitsUdbR3FClosed := false;
  // (  ).
  MaskaNam := '';
  FileNam := '';
  MaskiBox.Clear;
  FilesBox.Clear;
  FileLoaded := false;
  SaveBut.Enabled := false;
  DeleteBut.Enabled := false;
  ZashablonitBut.Enabled := false;
  DeactivateTable(Sender);
  // 
  ValuesEd.Cells[1,1] := '';
  ValuesEd.Cells[1,2] := '';
  ValuesEd.Cells[1,3] := '';
  ValuesEd.Cells[1,4] := '';
  ValuesEd.Cells[1,5] := '';
  ValuesEd.Cells[1,6] := '';
  ValuesEd.Cells[1,7] := '';
  ValuesEd.Cells[1,8] := '';
  ValuesEd.Cells[1,9] := '';
  ValuesEd.Cells[1,10] := '';
  ValuesEd.Cells[1,11] := '';
  ValuesEd.Cells[1,12] := '';
  ValuesEd.Cells[1,13] := '';
  ValuesEd.Cells[1,14] := '';
  ValuesEd.Cells[1,15] := '';
  ValuesEd.Cells[1,16] := '';
  ValuesEd.Cells[1,17] := '';
  ValuesEd.Cells[1,18] := '';
  ValuesEd.Cells[1,19] := '';
  ValuesEd.Cells[1,20] := '';
  ValuesEd.Cells[1,21] := '';
  ValuesEd.Cells[1,22] := '';
  ValuesEd.Cells[1,23] := '';
  ValuesEd.Cells[1,24] := '';
  ValuesEd.Cells[1,25] := '';
  ValuesEd.Cells[1,26] := '';
  ValuesEd.Cells[1,27] := '';
  ValuesEd.Cells[1,28] := '';
  ValuesEd.Cells[1,29] := '';
  ValuesEd.Cells[1,30] := '';
  ValuesEd.Cells[1,31] := '';
  ValuesEd.Cells[1,32] := '';
  ValuesEd.Cells[1,33] := '';
  ValuesEd.Cells[1,34] := '';
  ValuesEd.Cells[1,35] := '';
  ValuesEd.Cells[1,36] := '';
  ValuesEd.Cells[1,37] := '';
  ValuesEd.Cells[1,38] := '';
  ValuesEd.Cells[1,39] := '';
  ValuesEd.Cells[1,40] := '';
  ValuesEd.Cells[1,41] := '';
  ValuesEd.Cells[1,42] := '';
  ValuesEd.Cells[1,43] := '';
  ValuesEd.Cells[1,44] := '';
  ValuesEd.Cells[1,45] := '';
  ValuesEd.Cells[1,46] := '';
  ValuesEd.Cells[1,47] := '';
  ValuesEd.Cells[1,48] := '';
  ValuesEd.Cells[1,49] := '';
  ValuesEd.Cells[1,50] := '';
  ValuesEd.Cells[1,51] := '';
  ValuesEd.Cells[1,52] := '';
  ValuesEd.Cells[1,53] := '';
  ValuesEd.Cells[1,54] := '';
  ValuesEd.Cells[1,55] := '';
  ValuesEd.Cells[1,56] := '';
  ValuesEd.Cells[1,57] := '';
  ValuesEd.Cells[1,58] := '';
  ValuesEd.Cells[1,59] := '';
  ValuesEd.Cells[1,60] := '';
  ValuesEd.Cells[1,61] := '';
  ValuesEd.Cells[1,62] := '';

  //.     ...
  Fil1 := TFileInString.Init;
  Zap1 := TZapisBaziPZ.Init;
  //     .
  IshDir := DatabaselmpResIsh;     //  
  PathForForm := IshDir+'units\3\';     //   
  ShablonsPath := Path+'shablons\units\3\';  //  
  //ShowMessage(PathForForm);
  // ...
  If DirectoryExists(PathForForm) then begin
    // ,       ...
    I := 0;
    //FailEst : false;
    repeat
      I := I+1;
      FailEst := false;
      if FileExistsDiv(GenerateNumName(I,'')+'.zap',PathForForm) = true then begin
        // 
        FailEst := true;
        FilesBox.Items.Add(GenerateNumName(I,'')+'.zap');
        //  ...
        Indeks[I,1] := GenerateNumName(I,'')+'.zap';
        // ...
        Fil1.Load(PathForForm+Indeks[I,1]);
        Zap1.LoadZap(Fil1.FileString,Fil1.siz);
        MaskaNam := Zap1.GetField(1);
        //  .
        ResSt := MaskaNam;
        MaskaNam := '';
        For J := 1 to Zap1.SizFieldOtv-1 do begin
          MaskaNam := MaskaNam+ResSt[J];
        end;
        Indeks[I,2] := MaskaNam;
        MaskiBox.Items.Add(MaskaNam);
        //   ...
        For J := 1 to MaskiBox.Items.Capacity-1 do begin
        // 1 -      .
          If MaskaNam = Indeks[J,2] then begin
            MessageDLG('!!,   !',mtWarning,[mbOk],0);
          end;
        end;
        
      end;
    until FailEst = false;
  end
  else begin
    //! ,   !
    MessageDLG('  !      !',mtError,[mbOk],0);
    Close;
  end;
end;

procedure TUnitsUdbR3F.MaskiBoxClick(Sender: TObject);
var
  I : integer;
begin
  //     ...
  MaskaNam := MaskiBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to MaskiBox.Items.Capacity do begin
    If MaskaNam=Indeks[I,2] then FileNam := Indeks[I,1];
  end;
  //   
  For I := 0 to FilesBox.Items.Capacity-1 do begin
    //...  
    if FilesBox.Items.Strings[I] = FileNam then FilesBox.ItemIndex := I;
  end;
  LoadFil(PathForForm+FileNam,Sender);
end;

procedure TUnitsUdbR3F.FilesBoxClick(Sender: TObject);
var
  I : integer;
begin
  //  ...
  FileNam := FilesBox.Text;
  //ShowMessage(MaskaNam);
  For I := 1 to FilesBox.Items.Capacity do begin
    If FileNam=Indeks[I,1] then MaskaNam := Indeks[I,2];
  end;
  //   
  For I := 0 to MaskiBox.Items.Capacity-1 do begin
    //...  
    if MaskiBox.Items.Strings[I] = MaskaNam then MaskiBox.ItemIndex := I;
  end;
  // ...
  LoadFil(PathForForm+FileNam,Sender);
end;

Procedure TUnitsUdbR3F.LoadFil(const FilNam : string; Sender: TObject);
var
  BufSt, StToText, BufSt1 : string;
  BufSiz, I, int1, int2, int3 : integer;
  ChB : ChetireBaita;
  Flt : Single;
  UnkEmpty : boolean;
begin
  //  
  ActivateTable(Sender);
  Fil1.Load(FilNam);
  Zap1.LoadZap(Fil1.FileString,Fil1.siz);
  FileLoaded := true;
  SaveBut.Enabled := true;
  DeleteBut.Enabled := true;
  ZashablonitBut.Enabled := true;
  //       .
           
  //Name -  1  TEXT.
  ValuesEd.Cells[1,1] := PzDbStrToStr(Zap1.GetField(1));

  //Base Race -  2  TEXT.
  ValuesEd.Cells[1,2] := PzDbStrToStr(Zap1.GetField(2));

  //Unknown1 -  3  UnsLong.
  ValuesEd.Cells[1,3] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(3)));

  //Graphics Data Skin Index -  4  UnsLong.
  ValuesEd.Cells[1,4] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(4)));

  //Graphics Data Hair -  5  UnsLong.
  ValuesEd.Cells[1,5] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(5)));

  //Graphics Data Complection X -  6  FLOAT.
  ValuesEd.Cells[1,6] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(6)),7));

  //Graphics Data Complection Y -  7  FLOAT.
  ValuesEd.Cells[1,7] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(7)),7));

  //Graphics Data Complection Z -  8  FLOAT.
  ValuesEd.Cells[1,8] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(8)),7));

  //Unknown2 -  9  TEXT.
  ValuesEd.Cells[1,9] := PzDbStrToStr(Zap1.GetField(9));

  //Stats Health -  10  FLOAT.
  ValuesEd.Cells[1,10] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(10)),7));

  //Stats Mana -  11  FLOAT.
  ValuesEd.Cells[1,11] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(11)),7));

  //Stats Absorbtion -  12  FLOAT.
  ValuesEd.Cells[1,12] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(12)),7));

  //Tuning Actions -  13  FLOAT.
  ValuesEd.Cells[1,13] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(13)),7));

  //Tunig Move -  14  FLOAT.
  ValuesEd.Cells[1,14] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(14)),7));

  //Attack Range -  15  FLOAT.
  ValuesEd.Cells[1,15] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(15)),7));

  //Stats To hit -  16  FLOAT.
  ValuesEd.Cells[1,16] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(16)),7));

  //Stats Parry -  17  FLOAT.
  ValuesEd.Cells[1,17] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(17)),7));

  //Tuning Weapon Weight -  18  FLOAT.
  ValuesEd.Cells[1,18] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(18)),7));

  //ID Attack Weapon Type -  19  UnsLong. - ID.  -...
  BufSt :=  IntToStr(_4byteStrToUnsLong(Zap1.GetField(19)));
  If BufSt = '0' then begin
    BufSt := BufSt+'     SWORD';
  end;
  If BufSt = '1' then begin
    BufSt := BufSt+'     AXE';
  end;
  If BufSt = '2' then begin
    BufSt := BufSt+'     DAGGER';
  end;
  If BufSt = '3' then begin
    BufSt := BufSt+'     SPEAR';
  end;
  If BufSt = '4' then begin
    BufSt := BufSt+'     HAMMER';
  end;
  If BufSt = '5' then begin
    BufSt := BufSt+'     BOW';
  end;
  If BufSt = '8' then begin
    BufSt := BufSt+'     HANDS';
  end;
  If BufSt = '9' then begin
    BufSt := BufSt+'     HANDS1';
  end;
  If BufSt = '10' then begin
    BufSt := BufSt+'     HANDS2';
  end;
  If BufSt = '11' then begin
    BufSt := BufSt+'     HANDS3';
  end;
  If BufSt = '12' then begin
    BufSt := BufSt+'     HANDS4';
  end;
  If BufSt = '13' then begin
    BufSt := BufSt+'     HANDS5';
  end;
  If BufSt = '14' then begin
    BufSt := BufSt+'     HANDS6';
  end;
  If BufSt = '15' then begin
    BufSt := BufSt+'     HANDS7';
  end;
  If BufSt = '16' then begin
    BufSt := BufSt+'     MAGIC';
  end;
  ValuesEd.Cells[1,19] := BufSt;

  //Stats Damage Min -  20  FLOAT.
  ValuesEd.Cells[1,20] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(20)),7));

  //Stats Damage Max -  21  FLOAT.
  //   Stats Damage Min+Zap1.GetField(21) = Stats Damage Max
  ValuesEd.Cells[1,21] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(20)),7)+RoundFloat(_4byteStrToFloat(Zap1.GetField(21)),7));

  //Skills General -  22  FLOAT.
  ValuesEd.Cells[1,22] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(22)),7));

  //Skills Steal -  23  FLOAT.
  ValuesEd.Cells[1,23] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(23)),7));

  //Skills Tame -  24  FLOAT.
  ValuesEd.Cells[1,24] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(24)),7));

  //Skills Peripheral -  25  FLOAT.
  ValuesEd.Cells[1,25] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(25)),7));

  //Senses -  26   -    , 6 FLOAT .
  BufSt := Zap1.GetField(26);
  //Senses Sight. FLOAT. -  1.
  ValuesEd.Cells[1,26] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Senses Infra. FLOAT. -  2.
  ValuesEd.Cells[1,27] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Senses Senselife. FLOAT. -  3.
  ValuesEd.Cells[1,28] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Senses Hearing. FLOAT. -  4.
  ValuesEd.Cells[1,29] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Senses Smell. FLOAT. -  5.
  ValuesEd.Cells[1,30] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Senses Tracking. FLOAT. -  6.
  ValuesEd.Cells[1,31] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Detections -  27   -    , 6 FLOAT .
  BufSt := Zap1.GetField(27);
  //Detections Sight. FLOAT. -  1.
  ValuesEd.Cells[1,32] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Detections Infra. FLOAT. -  2.
  ValuesEd.Cells[1,33] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Detections Senselife. FLOAT. -  3.
  ValuesEd.Cells[1,34] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Detections Hearing. FLOAT. -  4.
  ValuesEd.Cells[1,35] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Detections Smell. FLOAT. -  5.
  ValuesEd.Cells[1,36] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Detections Tracking. FLOAT. -  6.
  ValuesEd.Cells[1,37] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Common loot -  28. .   0  3. (4 ).
  BufSt := Zap1.GetField(28);
  //Common loot Probability -  0  FLOAT.
  ValuesEd.Cells[1,38] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //Common loot Mask -  1  UnsLong.
  ValuesEd.Cells[1,39] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //Common loot Min -  2  FLOAT.
  ValuesEd.Cells[1,40] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //Common loot Max -  3  FLOAT.
  ValuesEd.Cells[1,41] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Rare loot -  29. .   0  3. (4 ).
  BufSt := Zap1.GetField(29);
  //Rare loot Probability -  0  FLOAT.
  ValuesEd.Cells[1,42] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //Rare loot Mask -  1  UnsLong.
  ValuesEd.Cells[1,43] := IntToStr(_4byteStrToUnsLong(OtkusitPodPole(@BufSt)));
  //Rare loot Min -  2  FLOAT.
  ValuesEd.Cells[1,44] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));
  //Rare loot Max -  3  FLOAT.
  ValuesEd.Cells[1,45] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitPodPole(@BufSt)),7));

  //Items -  30  List.
  ValuesEd.Cells[1,46] := ListToStr(Zap1.GetField(30));

  //Skills -  31   -    , 3 FLOAT .
  BufSt := Zap1.GetField(31);
  //Skills Elemental. FLOAT. -  1.
  ValuesEd.Cells[1,47] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Skills Senses. FLOAT. -  2.
  ValuesEd.Cells[1,48] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));
  //Skills Astral. FLOAT. -  3.
  ValuesEd.Cells[1,49] := FloatToStrMy(RoundFloat(_4byteStrToFloat(OtkusitStrokeBashku(@BufSt,4)),7));

  //Spells -  32  List.
  ValuesEd.Cells[1,50] := ListToStr(Zap1.GetField(32));

  //Equipment Wears -  33  List.
  ValuesEd.Cells[1,51] := ListToStr(Zap1.GetField(33));

  //Equipment Weapon 1 -  34  TEXT.
  ValuesEd.Cells[1,52] := PzDbStrToStr(Zap1.GetField(34));

  //Graphics Data Info Window Scale -  35  FLOAT.
  ValuesEd.Cells[1,53] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(35)),7));

  //Graphics Data Altitude -  36  FLOAT.
  ValuesEd.Cells[1,54] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(36)),7));

  //Tuning To hit Random -  37  FLOAT.
  ValuesEd.Cells[1,55] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(37)),7));

  //Graphics Data Dialog Camera Distance -  38  FLOAT.
  ValuesEd.Cells[1,56] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(38)),7));

  //Graphics Data Dialog Camera Height -  39  FLOAT.
  ValuesEd.Cells[1,57] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(39)),7));

  //ID Attack Real Weapon Type -  40  UnsLong. - ID.  -...
  BufSt :=  IntToStr(_4byteStrToUnsLong(Zap1.GetField(40)));
  If BufSt = '0' then begin
    BufSt := BufSt+'     SWORD';
  end;
  If BufSt = '1' then begin
    BufSt := BufSt+'     AXE';
  end;
  If BufSt = '2' then begin
    BufSt := BufSt+'     DAGGER';
  end;
  If BufSt = '3' then begin
    BufSt := BufSt+'     SPEAR';
  end;
  If BufSt = '4' then begin
    BufSt := BufSt+'     HAMMER';
  end;
  If BufSt = '5' then begin
    BufSt := BufSt+'     BOW';
  end;
  If BufSt = '8' then begin
    BufSt := BufSt+'     HANDS';
  end;
  If BufSt = '9' then begin
    BufSt := BufSt+'     HANDS1';
  end;
  If BufSt = '10' then begin
    BufSt := BufSt+'     HANDS2';
  end;
  If BufSt = '11' then begin
    BufSt := BufSt+'     HANDS3';
  end;
  If BufSt = '12' then begin
    BufSt := BufSt+'     HANDS4';
  end;
  If BufSt = '13' then begin
    BufSt := BufSt+'     HANDS5';
  end;
  If BufSt = '14' then begin
    BufSt := BufSt+'     HANDS6';
  end;
  If BufSt = '15' then begin
    BufSt := BufSt+'     HANDS7';
  end;
  If BufSt = '16' then begin
    BufSt := BufSt+'     MAGIC';
  end;
  ValuesEd.Cells[1,58] := BufSt;

  //Graphics Data Detonation -  41  FLOAT.
  ValuesEd.Cells[1,59] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(41)),7));

  //Base Level -  42  UnsLong.
  ValuesEd.Cells[1,60] := IntToStr(_4byteStrToUnsLong(Zap1.GetField(42)));

  //Equipment Weapon 2 -  43  TEXT.
  ValuesEd.Cells[1,61] := PzDbStrToStr(Zap1.GetField(43));

  //Graphics Data Detonation -  44  FLOAT.
  ValuesEd.Cells[1,62] := FloatToStrMy(RoundFloat(_4byteStrToFloat(Zap1.GetField(44)),7));

end;

Function TUnitsUdbR3F.GenZap(Sender : TObject): boolean;
//      
//         .
var
  BufSt, Res1St, BufSt1, BufSt2, ErrorMsgStr : string;
  SizBufSt, I, int1, int2 : integer;
  bf1 : char;
  Flt1 : Extended;
  ChB : ChetireBaita;
  AllOk : boolean;
begin
  //   
  AllOk := true;
  ErrorMsgStr := '';

  if CheckMaska2(ValuesEd.Cells[1,1],MaskiBox.ItemIndex) = false then begin
    AllOk := false;
    //Name
    ValuesEd.Selection := SelGridRect(1,1);
    ErrorMsgStr := '  -   .     .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,3]) = false then begin
    AllOk := false;
    //Unknown1
    ValuesEd.Selection := SelGridRect(1,3);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,4]) = false then begin
    AllOk := false;
    //Graphics Data Skin Index
    ValuesEd.Selection := SelGridRect(1,4);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,5]) = false then begin
    AllOk := false;
    //Graphics Data Hair
    ValuesEd.Selection := SelGridRect(1,5);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,6]) = false then begin
    AllOk := false;
    //Graphics Data Complection X
    ValuesEd.Selection := SelGridRect(1,6);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,7]) = false then begin
    AllOk := false;
    //Graphics Data Complection Y
    ValuesEd.Selection := SelGridRect(1,7);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,8]) = false then begin
    AllOk := false;
    //Graphics Data Complection Z
    ValuesEd.Selection := SelGridRect(1,8);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,10]) = false then begin
    AllOk := false;
    //Stats Health
    ValuesEd.Selection := SelGridRect(1,10);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,11]) = false then begin
    AllOk := false;
    //Stats Mana
    ValuesEd.Selection := SelGridRect(1,11);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,12]) = false then begin
    AllOk := false;
    //Stats Absorbtion
    ValuesEd.Selection := SelGridRect(1,12);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,13]) = false then begin
    AllOk := false;
    //Tuning Actions
    ValuesEd.Selection := SelGridRect(1,13);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,14]) = false then begin
    AllOk := false;
    //Tunig Move
    ValuesEd.Selection := SelGridRect(1,14);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,15]) = false then begin
    AllOk := false;
    //Attack Range
    ValuesEd.Selection := SelGridRect(1,15);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,16]) = false then begin
    AllOk := false;
    //Stats To hit
    ValuesEd.Selection := SelGridRect(1,16);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,17]) = false then begin
    AllOk := false;
    //Stats Parry
    ValuesEd.Selection := SelGridRect(1,17);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,18]) = false then begin
    AllOk := false;
    //Tuning Weapon Weight
    ValuesEd.Selection := SelGridRect(1,18);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(FilterValue(ValuesEd.Cells[1,19])) = false then begin
    AllOk := false;
    //Attack Weapon Type ID.    !!!
    ValuesEd.Selection := SelGridRect(1,19);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,20]) = false then begin
    AllOk := false;
    //Stats Damage Min
    ValuesEd.Selection := SelGridRect(1,20);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,21]) = false then begin
    AllOk := false;
    //Stats Damage Max
    ValuesEd.Selection := SelGridRect(1,21);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,22]) = false then begin
    AllOk := false;
    //Skills General
    ValuesEd.Selection := SelGridRect(1,22);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,23]) = false then begin
    AllOk := false;
    //Skills Steal
    ValuesEd.Selection := SelGridRect(1,23);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,24]) = false then begin
    AllOk := false;
    //Skills Tame
    ValuesEd.Selection := SelGridRect(1,24);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,25]) = false then begin
    AllOk := false;
    //Skills Peripheral
    ValuesEd.Selection := SelGridRect(1,25);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,26]) = false then begin
    AllOk := false;
    //Senses Sight
    ValuesEd.Selection := SelGridRect(1,26);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,27]) = false then begin
    AllOk := false;
    //Senses Infra
    ValuesEd.Selection := SelGridRect(1,27);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,28]) = false then begin
    AllOk := false;
    //Senses Senselife
    ValuesEd.Selection := SelGridRect(1,28);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,29]) = false then begin
    AllOk := false;
    //Senses Hearing
    ValuesEd.Selection := SelGridRect(1,29);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,30]) = false then begin
    AllOk := false;
    //Senses Smell
    ValuesEd.Selection := SelGridRect(1,30);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,31]) = false then begin
    AllOk := false;
    //Senses Tracking
    ValuesEd.Selection := SelGridRect(1,31);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,32]) = false then begin
    AllOk := false;
    //Detections Sight
    ValuesEd.Selection := SelGridRect(1,32);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,33]) = false then begin
    AllOk := false;
    //Detections Infra
    ValuesEd.Selection := SelGridRect(1,33);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,34]) = false then begin
    AllOk := false;
    //Detections Senselife
    ValuesEd.Selection := SelGridRect(1,34);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,35]) = false then begin
    AllOk := false;
    //Detections Hearing
    ValuesEd.Selection := SelGridRect(1,35);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,36]) = false then begin
    AllOk := false;
    //Detections Smell
    ValuesEd.Selection := SelGridRect(1,36);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,37]) = false then begin
    AllOk := false;
    //Detections Tracking
    ValuesEd.Selection := SelGridRect(1,37);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,38]) = false then begin
    AllOk := false;
    //Common loot Probability
    ValuesEd.Selection := SelGridRect(1,38);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,39]) = false then begin
    AllOk := false;
    //Common loot Mask
    ValuesEd.Selection := SelGridRect(1,39);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,40]) = false then begin
    AllOk := false;
    //Common loot Min
    ValuesEd.Selection := SelGridRect(1,40);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,41]) = false then begin
    AllOk := false;
    //Common loot Max
    ValuesEd.Selection := SelGridRect(1,41);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,42]) = false then begin
    AllOk := false;
    //Rare loot Probability
    ValuesEd.Selection := SelGridRect(1,42);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,43]) = false then begin
    AllOk := false;
    //Rare loot Mask
    ValuesEd.Selection := SelGridRect(1,43);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,44]) = false then begin
    AllOk := false;
    //Rare loot Min
    ValuesEd.Selection := SelGridRect(1,44);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,45]) = false then begin
    AllOk := false;
    //Rare loot Max
    ValuesEd.Selection := SelGridRect(1,45);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckList(ValuesEd.Cells[1,46]) = false then begin
    AllOk := false;
    //Items
    ValuesEd.Selection := SelGridRect(1,46);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,46] := ListBezProbelov(ValuesEd.Cells[1,46]);
    if CheckList(ValuesEd.Cells[1,46]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,46);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,47]) = false then begin
    AllOk := false;
    //Skills Elemental
    ValuesEd.Selection := SelGridRect(1,47);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,48]) = false then begin
    AllOk := false;
    //Skills Senses
    ValuesEd.Selection := SelGridRect(1,48);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,49]) = false then begin
    AllOk := false;
    //Skills Astral
    ValuesEd.Selection := SelGridRect(1,49);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckList(ValuesEd.Cells[1,50]) = false then begin
    AllOk := false;
    //Spells
    ValuesEd.Selection := SelGridRect(1,50);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,50] := ListBezProbelov(ValuesEd.Cells[1,50]);
    if CheckList(ValuesEd.Cells[1,50]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,50);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckList(ValuesEd.Cells[1,51]) = false then begin
    AllOk := false;
    //Equipment Wears
    ValuesEd.Selection := SelGridRect(1,51);
    ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
    Beep;
  end
  else begin
    // ,    .
    ValuesEd.Cells[1,51] := ListBezProbelov(ValuesEd.Cells[1,51]);
    if CheckList(ValuesEd.Cells[1,51]) = false then begin
      AllOk := false;
      ValuesEd.Selection := SelGridRect(1,51);
      ErrorMsgStr := '    .'+#13+'     ,  .        , 2-     ,   ( ) .';
      Beep;
    end;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,53]) = false then begin
    AllOk := false;
    //Graphics Data Info Window Scale
    ValuesEd.Selection := SelGridRect(1,53);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,54]) = false then begin
    AllOk := false;
    //Graphics Data Altitude
    ValuesEd.Selection := SelGridRect(1,54);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,55]) = false then begin
    AllOk := false;
    //Tuning To hit Random
    ValuesEd.Selection := SelGridRect(1,55);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,56]) = false then begin
    AllOk := false;
    //Graphics Data Dialog Camera Distance
    ValuesEd.Selection := SelGridRect(1,56);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,57]) = false then begin
    AllOk := false;
    //Graphics Data Dialog Camera Height
    ValuesEd.Selection := SelGridRect(1,57);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(FilterValue(ValuesEd.Cells[1,58])) = false then begin
    AllOk := false;
    //Attack Real Weapon Type ID.    !!!
    ValuesEd.Selection := SelGridRect(1,58);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,59]) = false then begin
    AllOk := false;
    //Graphics Data Detonation
    ValuesEd.Selection := SelGridRect(1,59);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrInt(ValuesEd.Cells[1,60]) = false then begin
    AllOk := false;
    //Base Level
    ValuesEd.Selection := SelGridRect(1,60);
    ErrorMsgStr := '    .';
    Beep;
  end;

  if CheckStrFloat(ValuesEd.Cells[1,62]) = false then begin
    AllOk := false;
    //Stats Exp
    ValuesEd.Selection := SelGridRect(1,62);
    ErrorMsgStr := '    .';
    Beep;
  end;

  //   (   )
  If AllOk = true then begin

    //Name.  1. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,1]);
    Zap1.ReWriteField(1,Length(BufSt),BufSt);

    //Base Race.  2. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,2]);
    Zap1.ReWriteField(2,Length(BufSt),BufSt);

    //Unknown1.  3. UnsLong.
    Zap1.ReWriteField(3,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,3])));

    //Graphics Data Skin Index.  4. UnsLong.
    Zap1.ReWriteField(4,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,4])));

    //Graphics Data Hair.  5. UnsLong.
    Zap1.ReWriteField(5,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,5])));

    //Graphics Data Complection X.  6. FLOAT.
    Zap1.ReWriteField(6,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,6])));

    //Graphics Data Complection Y.  7. FLOAT.
    Zap1.ReWriteField(7,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,7])));

    //Graphics Data Complection Z.  8. FLOAT.
    Zap1.ReWriteField(8,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,8])));

    //Unknown2.  9. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,9]);
    Zap1.ReWriteField(9,Length(BufSt),BufSt);

    //Stats Health.  10. FLOAT.
    Zap1.ReWriteField(10,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,10])));

    //Stats Mana.  11. FLOAT.
    Zap1.ReWriteField(11,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,11])));

    //Stats Absorbtion.  12. FLOAT.
    Zap1.ReWriteField(12,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,12])));

    //Tuning Actions.  13. FLOAT.
    Zap1.ReWriteField(13,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,13])));

    //Tunig Move.  14. FLOAT.
    Zap1.ReWriteField(14,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,14])));

    //Attack Range.  15. FLOAT.
    Zap1.ReWriteField(15,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,15])));

    //Stats To hit.  16. FLOAT.
    Zap1.ReWriteField(16,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,16])));

    //Stats Parry.  17. FLOAT.
    Zap1.ReWriteField(17,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,17])));

    //Tuning Weapon Weight.  18. FLOAT.
    Zap1.ReWriteField(18,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,18])));

    //Attack Weapon Type ID.  19. UnsLong.    .
    Zap1.ReWriteField(19,4,UnsLongTo4byteStr(StrToInt(FilterValue(ValuesEd.Cells[1,19]))));

    //Stats Damage Min.  20. FLOAT.
    Zap1.ReWriteField(20,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,20])));

    //Stats Damage Max - Stats Damage Min.  21. FLOAT.
    Zap1.ReWriteField(21,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,21])-StrToFloat2(ValuesEd.Cells[1,20])));

    //Skills General.  22. FLOAT.
    Zap1.ReWriteField(22,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,22])));

    //Skills Steal.  23. FLOAT.
    Zap1.ReWriteField(23,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,23])));

    //Skills Tame.  24. FLOAT.
    Zap1.ReWriteField(24,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,24])));

    //Skills Peripheral.  25. FLOAT.
    Zap1.ReWriteField(25,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,25])));

    //Senses.  26. 6 FLOAT .
    BufSt := '';
    //Senses Sight
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,26]));
    //Senses Infra
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,27]));
    //Senses Senselife
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,28]));
    //Senses Hearing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,29]));
    //Senses Smell
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,30]));
    //Senses Tracking
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,31]));
    Zap1.ReWriteField(26,24,BufSt);

    //Detections.  27. 6 FLOAT .
    BufSt := '';
    //Detections Sight
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,32]));
    //Detections Infra
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,33]));
    //Detections Senselife
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,34]));
    //Detections Hearing
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,35]));
    //Detections Smell
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,36]));
    //Detections Tracking
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,37]));
    Zap1.ReWriteField(27,24,BufSt);

    //Common loot.  28. .   0  3 (4 ).
    BufSt := '';
    //Common loot Probability. FLOAT. -  0.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,38])),0);
    //Common loot Mask. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,39])),1);
    //Common loot Min. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,40])),2);
    //Common loot Max. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,41])),3);
    //  ...
    Zap1.ReWriteField(28,Length(BufSt),BufSt);

    //Rare loot.  29. .   0  3 (4 ).
    BufSt := '';
    //Rare loot Probability. FLOAT. -  0.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,42])),0);
    //Rare loot Mask. UnsLong. -  1.
    BufSt := AddPodPole(BufSt,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,43])),1);
    //Rare loot Min. FLOAT. -  2.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,44])),2);
    //Rare loot Max. FLOAT. -  3.
    BufSt := AddPodPole(BufSt,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,45])),3);
    //  ...
    Zap1.ReWriteField(29,Length(BufSt),BufSt);

    //Items.  30. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,46]);
    Zap1.ReWriteField(30,Length(BufSt),BufSt);

    //Skills.  31. 3 FLOAT .
    BufSt := '';
    //Skills Elemental
    BufSt := FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,47]));
    //Skills Senses
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,48]));
    //Skills Astral
    BufSt := BufSt+FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,49]));
    Zap1.ReWriteField(31,12,BufSt);

    //Spells.  32. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,50]);
    Zap1.ReWriteField(32,Length(BufSt),BufSt);

    //Equipment Wears.  33. LIST.
    BufSt := StrToList(ValuesEd.Cells[1,51]);
    Zap1.ReWriteField(33,Length(BufSt),BufSt);

    //Equipment Weapon 1.  34. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,52]);
    Zap1.ReWriteField(34,Length(BufSt),BufSt);

    //Graphics Data Info Window Scale.  35. FLOAT.
    Zap1.ReWriteField(35,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,53])));

    //Graphics Data Altitude.  36. FLOAT.
    Zap1.ReWriteField(36,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,54])));

    //Tuning To hit Random.  37. FLOAT.
    Zap1.ReWriteField(37,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,55])));

    //Graphics Data Dialog Camera Distance.  38. FLOAT.
    Zap1.ReWriteField(38,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,56])));

    //Graphics Data Dialog Camera Height.  39. FLOAT.
    Zap1.ReWriteField(39,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,57])));

    //Attack Real Weapon Type ID.  40. UnsLong.    .
    Zap1.ReWriteField(40,4,UnsLongTo4byteStr(StrToInt(FilterValue(ValuesEd.Cells[1,58]))));

    //Graphics Data Detonation.  41. FLOAT.
    Zap1.ReWriteField(41,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,59])));

    //Base Level.  42. UnsLong.
    Zap1.ReWriteField(42,4,UnsLongTo4byteStr(StrToInt(ValuesEd.Cells[1,60])));

    //Equipment Weapon 2.  43. TEXT.
    BufSt := StrToPzDbStr2(ValuesEd.Cells[1,61]);
    Zap1.ReWriteField(43,Length(BufSt),BufSt);

    //Stats Exp.  44. FLOAT.
    Zap1.ReWriteField(44,4,FloatTo4byteStr(StrToFloat2(ValuesEd.Cells[1,62])));

    //  ...
    Zap1.BuildZap;
    result := true;
  end
  else begin
    MessageDLG(ErrorMsgStr,mtError,[mbOk],0);
    ValuesEd.SetFocus;
    result := false;  //   .
  end;
end;

Procedure TUnitsUdbR3F.ActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = false then begin
    //     .
    ValuesEd.ItemProps[18].EditStyle := esEllipsis;
    ValuesEd.ItemProps[57].EditStyle := esEllipsis;
    TableActivated := true;
  end;
end;

Procedure TUnitsUdbR3F.DeActivateTable(Sender : TObject);
begin
  //    .
  If TableActivated = true then begin
    //    .
    ValuesEd.ItemProps[18].EditStyle := esSimple;
    ValuesEd.ItemProps[57].EditStyle := esSimple;
    TableActivated := false;
  end;
end;

Function CheckMaska(const Maska : string) : boolean;
var
  J : integer;
begin
  //    .
  Result := true;
  For J := 0 to UnitsUdbR3F.MaskiBox.Items.Capacity-1 do begin
    If UnitsUdbR3F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

Function CheckMaska2(const Maska : string; IndAcr : integer) : boolean;
var
  J : integer;
begin
  //    ,   ...
  Result := true;
  For J := 0 to UnitsUdbR3F.MaskiBox.Items.Capacity-1 do begin
    If J <> IndAcr then If UnitsUdbR3F.MaskiBox.Items.Strings[J] = Maska then Result := false;
  end;
end;

procedure TUnitsUdbR3F.ZashablonitButClick(Sender: TObject);
var
  ShablName : string;
begin
  //        .
  //        
  //   - 
  If GenZap(Sender) = true then begin
    //     ( )
    ShablonimF.ShablsPath := ShablonsPath;
    ShablonimF.ShowModal;
    If ShablonimF.ModalResult = mrOk then begin
      //  ..
      ShablName := GetFileName(ShablonimF.ShablPath);

      // 
      PzDbStrRec := StrToPzDbStr(ShablName);
      Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);
      Zap1.BuildZap;

      //...
      Fil1.FileString := Zap1.ZapisString;
      //Fil1.Siz := Zap1.Siz;
      Fil1.Save(ShablonimF.ShablPath);
    end;
  end;
end;

procedure TUnitsUdbR3F.SaveButClick(Sender: TObject);
var
  I : integer;

begin
  //  ...
  //     -   
  If GenZap(Sender) = true then begin
    //  ...
    Fil1.FileString := Zap1.ZapisString;
    //Fil1.Siz := Zap1.Siz;
    Fil1.Save(PathForForm+FileNam);
    //   .
    I := MaskiBox.ItemIndex;
    indeks[I+1,2] := ValuesEd.Cells[1,1];
    MaskiBox.Items.Strings[I] := ValuesEd.Cells[1,1];
    MaskiBox.ItemIndex := I;
  end;
end;

procedure TUnitsUdbR3F.CloseButClick(Sender: TObject);
begin
  Close;
end;

procedure TUnitsUdbR3F.CreateButClick(Sender: TObject);
var
  ind1, Ind2 : boolean;
  Maska, FNam, ShablNam : string;
  I, J : integer;
begin
  //    .
  // ,    ...
  ind1 := false;
  repeat
    AskFnForm.QuestionDial := '   Name    ():';
    AskFnForm.ShowModal;
    if AskFnForm.ModalResult = MrOk then begin
      Maska := AskFnForm.AnswerDial;
      if CheckMaska(Maska) = true then begin
        //  .

        //   .
        ShablonimF.ShablsPath := ShablonsPath;
        CheckShablF.ShowModal;
        //     
        // -  .

        If CheckShablF.ModalResult = mrOk then begin
          //ShowMessage(ShablPath);
          // ...
          //  ...
          I := 0;
          repeat
            Ind2 := true;
            I := I+1;
            FNam := GenerateNumName(I,'')+'.zap';
            For J := 0 to FilesBox.Items.Capacity-1 do begin
              if FNam = FilesBox.Items.Strings[J] then ind2 := false;
            end;
          until ind2 = true;
          FileNam := FNam;

          //  ,    (), 
          //   .

          //,  

          Fil1.Load(ShablonimF.ShablPath);
          Zap1.LoadZap(Fil1.FileString,Fil1.siz);

          // ...

          PzDbStrRec := StrToPzDbStr(Maska);
          Zap1.ReWriteField(1,PzDbStrRec.Siz,PzDbStrRec.Str);

          //  ...

          Zap1.BuildZap;

          //...
          Fil1.FileString := Zap1.ZapisString;
          //Fil1.Siz := Zap1.Siz;
          Fil1.Save(PathForForm+FileNam);

          //.  .
          FormShow(Sender);

          //      .
          FilesBox.ItemIndex := FilesBox.Items.Capacity-1;
          FilesBoxClick(Sender);


          //  1...
          ind1 := true;
        end
        else begin
          // ...
          //  1...
          ind1 := true;
        end;
      end
      else begin
        //  .
        MessageDLG('!      !   !',mtError,[mbOk],0);
      end;
    end
    else begin
      //     
      ind1 := true;
    end;
  until ind1 = true;
end;

procedure TUnitsUdbR3F.DeleteButClick(Sender: TObject);
var
  OldIndex : integer;
begin
  If MessageDLG('    ?',mtConfirmation,[mbYes]+[mbNo],0) = mrYes then begin
    //   .
    DeleteFile(PathForForm+FileNam);
    //   ...
    VipravitFaili(PathForForm);
    //   ...
    //  ...
    Fil1.Free;
    Zap1.Free;
    OldIndex := FilesBox.ItemIndex;
    FilesBox.Clear;
    MaskiBox.Clear;
    MaskaNam := '';
    FileNam := '';
    FormShow(sender);
    //      
    //   1  .
    If OldIndex = FilesBox.Items.Capacity then OldIndex := OldIndex-1;
    //   .
    FilesBox.ItemIndex := OldIndex;
    // .
    FilesBoxClick(Sender);
  end;
end;

procedure TUnitsUdbR3F.ValuesEdEditButtonClick(Sender: TObject);
var
  BufSt : string;
  Idx : Integer;
begin
  //     .
  //    .

  //  - ""  -   .
  //    -  .

  If GenZap(Sender) = true then begin
  
    If ValuesEd.Row = 19 then begin
      //       ...
      //  -  ...
      Idx := 0; //  ....
      If FilterValue(ValuesEd.Cells[1,19]) = '0' then begin
        Idx := 0;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '1' then begin
        Idx := 1;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '2' then begin
        Idx := 2;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '3' then begin
        Idx := 3;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '4' then begin
        Idx := 4;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '5' then begin
        Idx := 5;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '8' then begin
        Idx := 6;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '9' then begin
        Idx := 7;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '10' then begin
        Idx := 8;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '11' then begin
        Idx := 9;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '12' then begin
        Idx := 10;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '13' then begin
        Idx := 11;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '14' then begin
        Idx := 12;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '15' then begin
        Idx := 13;
      end;
      If FilterValue(ValuesEd.Cells[1,19]) = '16' then begin
        Idx := 14;
      end;
      BufSt := SelectValueEx('0     SWORD'+#13+'1     AXE'+#13+'2     DAGGER'+#13+'3     SPEAR'+#13+'4     HAMMER'+#13+'5     BOW'+#13+'8     HANDS'+#13+'9     HANDS1'+#13+'10     HANDS2'+#13+'11     HANDS3'+#13+'12     HANDS4'+#13+'13     HANDS5'+#13+'14     HANDS6'+#13+'15     HANDS7'+#13+'16     MAGIC'+#13,Idx);
      If BufSt <> #13 then begin
        //    ...
        ValuesEd.Cells[1,19] := BufSt;
      end;
    end;

    If ValuesEd.Row = 58 then begin
      //       ...
      //  -  ...
      Idx := 0; //  ....
      If FilterValue(ValuesEd.Cells[1,58]) = '0' then begin
        Idx := 0;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '1' then begin
        Idx := 1;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '2' then begin
        Idx := 2;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '3' then begin
        Idx := 3;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '4' then begin
        Idx := 4;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '5' then begin
        Idx := 5;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '8' then begin
        Idx := 6;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '9' then begin
        Idx := 7;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '10' then begin
        Idx := 8;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '11' then begin
        Idx := 9;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '12' then begin
        Idx := 10;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '13' then begin
        Idx := 11;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '14' then begin
        Idx := 12;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '15' then begin
        Idx := 13;
      end;
      If FilterValue(ValuesEd.Cells[1,58]) = '16' then begin
        Idx := 14;
      end;
      BufSt := SelectValueEx('0     SWORD'+#13+'1     AXE'+#13+'2     DAGGER'+#13+'3     SPEAR'+#13+'4     HAMMER'+#13+'5     BOW'+#13+'8     HANDS'+#13+'9     HANDS1'+#13+'10     HANDS2'+#13+'11     HANDS3'+#13+'12     HANDS4'+#13+'13     HANDS5'+#13+'14     HANDS6'+#13+'15     HANDS7'+#13+'16     MAGIC'+#13,Idx);
      If BufSt <> #13 then begin
        //    ...
        ValuesEd.Cells[1,58] := BufSt;
      end;
    end;

  end;
end;

procedure TUnitsUdbR3F.SortButClick(Sender: TObject);
var
  SortInd : MaskFileArr;
  SortIndLength, i : integer;
  OldSourcePath : String;
  DirFile : File;

begin
  //      -  .
  if FilesBox.Items.Capacity > 1 then begin
    //  .
    SortInd := SortStringFileArray(Indeks);

    //    ...
    //  ...
    OldSourcePath := PathForForm;
    SetLength(OldSourcePath,Length(OldSourcePath)-1);
    OldSourcePath := OldSourcePath+'_old\';
    If DirectoryExists(OldSourcePath) = true then begin
      //      .
      ClearDir(OldSourcePath,true);
    end;
    RenameDir(PathForForm,OldSourcePath);

    //  .
    CreateDir(DelLastSlash(PathForForm));

    // -  (   - )
    //   ...
    i := 0;
    repeat
      //      .
      //    indeks     ,
      //       

      i := i+1;
      RenameFile(OldSourcePath+SortInd[i,1],PathForForm+Indeks[i,1]);
    until SortInd[i+1,1] = '';

    //   
    ClearDir(OldSourcePath,true);

    //   -     .
    FormShow(Sender);
  end;  
end;

end.
