///////////////////////////////////////////////////////////
//                        EiEdit                         //
//                   //
//             Copyright (C) 2002 Gipat Group            //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

unit ViborTipaTegaF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, initer;

type
  TViborTipaTegaForm = class(TForm)
    Rg1: TRadioGroup;
    DESCRb: TRadioButton;
    showRb: TRadioButton;
    ANIMATIONRb: TRadioButton;
    CAMERARb: TRadioButton;
    phraseRb: TRadioButton;
    NOLIPSRb: TRadioButton;
    Label1: TLabel;
    OkButn: TButton;
    CancelButn: TButton;
    OtherRb: TRadioButton;
    procedure OkButnClick(Sender: TObject);
    procedure CancelButnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DESCRbClick(Sender: TObject);
    procedure showRbClick(Sender: TObject);
    procedure ANIMATIONRbClick(Sender: TObject);
    procedure CAMERARbClick(Sender: TObject);
    procedure phraseRbClick(Sender: TObject);
    procedure NOLIPSRbClick(Sender: TObject);
    procedure OtherRbClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    TipTega : string;
  end;

var
  ViborTipaTegaForm: TViborTipaTegaForm;

implementation

{$R *.DFM}

procedure TViborTipaTegaForm.OkButnClick(Sender: TObject);
begin
  TipTega := 'nil';
  If DescRb.Checked then TipTega :='#DESC';
  If ShowRb.Checked then TipTega := '#show';
  if AnimationRb.Checked then TipTega := '#ANIMATION';
  If CameraRb.Checked then TipTega := '#CAMERA';
  If PhraseRb.Checked then TipTega := '#phrase';
  If NolipsRb.Checked then TipTega := '#NOLIPS';
  If OtherRb.Checked then TipTega := 'OTHER';
  ModalResult := MrOk;
end;

procedure TViborTipaTegaForm.CancelButnClick(Sender: TObject);
begin
  ModalResult := MrCancel;
end;

procedure TViborTipaTegaForm.FormShow(Sender: TObject);
begin
  OkButn.Enabled := false;
  DescRb.Checked := false;
  ShowRb.Checked := false;
  AnimationRb.Checked := false;
  CameraRb.Checked := false;
  PhraseRb.Checked := false;
  NolipsRb.Checked := false;
end;

procedure TViborTipaTegaForm.DESCRbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

procedure TViborTipaTegaForm.showRbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

procedure TViborTipaTegaForm.ANIMATIONRbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

procedure TViborTipaTegaForm.CAMERARbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

procedure TViborTipaTegaForm.phraseRbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

procedure TViborTipaTegaForm.NOLIPSRbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

procedure TViborTipaTegaForm.OtherRbClick(Sender: TObject);
begin
  OkButn.Enabled := true;
end;

end.
